
Option Explicit On


NameSpace CalcCn

Friend Class clsIniRW

	Private Shared mstrIniFileName			as String
	Private Shared mstrIniFileNameTemp		as String

	Private Const mstrKey_BnArray			As String = "AnArray_"

	Public Shared Property IniKey( ByVal strKey As System.String ) As String
	Get

		' ライン抜き出し
		Dim sr		As System.IO.StreamReader

		Try
			sr    = new System.IO.StreamReader( mstrIniFileName )
		Catch e As System.Exception
			Call clsPub.ErrMsg( _
					new System.Diagnostics.StackTrace( true ) , _ 
					 " 開けない！ ファイル名 = " & mstrIniFileName )
			Return Nothing
		End Try



		Dim strLine			As String
		Dim strValue		As String

		strValue = Nothing
		strLine = sr.ReadLine()
		Do While strLine IsNot Nothing

			If strLine.StartsWith( strKey & "=" ) Then
				strValue = strLine.Substring( strKey.Length + 1 )
				Exit Do
			End If

			strLine = sr.ReadLine()
		Loop

		sr.Close()
		sr.Dispose()
		sr = Nothing

		Return strValue
	End Get


	Set( ByVal strValue As String )

		' ライン抜き出し

		Dim sr		As System.IO.StreamReader
		Dim srout	As System.IO.StreamWriter

		Try
			sr    = new System.IO.StreamReader( mstrIniFileName )
		Catch e As System.Exception
			' TypeOf
			' GetType

			Call clsPub.ErrMsg( _
					new System.Diagnostics.StackTrace( true ) , _ 
					 " 読めない！ ファイル名 = " & mstrIniFileName )
			Exit Property
		End Try

		Try
			System.IO.File.Delete( mstrIniFileNameTemp )
		catch e as System.Exception
		End Try

		Try
			srout = new System.IO.StreamWriter( mstrIniFileNameTemp )
		catch e as System.Exception
			Call clsPub.ErrMsg( _
					new System.Diagnostics.StackTrace( true ) , _ 
					 " 開けない！ ファイル名 = " & mstrIniFileNameTemp )
			Exit Property
		End Try

		Dim strLine			As String
		Dim blAdded			As Boolean

		blAdded = false
		strLine = sr.ReadLine()
		Do While strLine IsNot Nothing

			If blAdded = false And strLine.StartsWith( strKey & "=" ) Then
				srout.WriteLine( _ 
						strKey & "=" & strValue )
				blAdded = true
			ElseIf strLine.Length > 0 Then
				srout.WriteLine( strLine )
			End If

			strLine = sr.ReadLine()
		Loop
		If blAdded = false Then
			srout.WriteLine( strKey & "=" & strValue )
		End If

		sr.Close()
		srout.Close()
		sr.Dispose()
		srout.Dispose()
		sr = Nothing
		srout = Nothing

		Try
			' https://docs.microsoft.com/ja-jp/dotnet/api/system.io.file.move?view=net-6.0#system-io-file-move(system-string-system-string-system-boolean)
			System.IO.File.Delete( mstrIniFileName )
			System.IO.File.Move( mstrIniFileNameTemp, mstrIniFileName )
		catch e as System.Exception
			Call clsPub.ErrMsg( _
					new System.Diagnostics.StackTrace( true ) , _ 
					" 削除or上書きできない！ 移動元ファイル名 = " & mstrIniFileNameTemp, _ 
					" 移動先ファイル名 = " & mstrIniFileName )
		End Try
		
		Return
	End Set
	End Property


#If 0
	Public Shared Property IniKey_frmClrTbl_ItemViewOuts() As Boolean
	Get
		If clsIniRW.IniKey( mstrKey_frmClrTbl_ItemViewOuts ) _
				= "false" Then
			Return false
		End If
		Return True
	End Get
	Set( ByVal blnValue As Boolean )
		Dim strValue	As String
		If blnValue Then
			strValue = "true"
		Else
			strValue = "false"
		End If
		
		clsIniRW.IniKey( mstrKey_frmClrTbl_ItemViewOuts ) = strValue
	End Set
	End Property
 #End If


	Public Shared Sub Init()
		' http://cammy.co.jp/technical/2017/06/16/c-ファイルの読み書きstreamreaderstreamwriter/
		mstrIniFileName = _
		System.Reflection.Assembly.GetExecutingAssembly().Location

		mstrIniFileNameTemp = System.IO.Path.ChangeExtension(mstrIniFileName & "_temp", "ini")
		mstrIniFileName = System.IO.Path.ChangeExtension(mstrIniFileName, "ini")



		' ファイルが読めるか一応開いて確かめる。
		Try
			dim sr as System.IO.StreamReader
			sr = new System.IO.StreamReader( mstrIniFileName )
			sr.Close()
			sr.Dispose()
		catch e as System.Exception
			Call clsPub.ErrMsg( _
					new System.Diagnostics.StackTrace( true ) , _ 
					" よめない！ ファイル名 = " & mstrIniFileName )
		End Try

		' 起動時に_tempファイルが残ってたらとりあえず自動削除
		Try
			System.IO.File.Delete( mstrIniFileNameTemp )
		catch e as System.Exception
			Call clsPub.ErrMsg( _
					new System.Diagnostics.StackTrace( true ) , _ 
					 " 消せない！ ファイル名 = " & mstrIniFileNameTemp )
		End Try
		

	End Sub

	Public Shared Sub GetIniKey_AnArray( ByVal n As Integer, ByRef arsStrNum() as String )

		Dim strValue	As String

		strValue = clsIniRW.IniKey( mstrKey_BnArray & n.ToString() )
		' https://docs.microsoft.com/ja-jp/dotnet/api/system.string.split?view=netframework-3.5
		arsStrNum = strValue.Split( " "C )

		' Splitはもっと上位でやった方がいいような・・・
		' Split のサンプルとして一応残しておくか。使わないけど。
	End Sub

	




End Class



End NameSpace
