﻿
Option Explicit On

NameSpace CalcCn

Friend Class clsStringNumber


	Friend Structure stDivideResult
		Dim objQuotient			As clsStringNumber
		Dim objRemainder		As clsStringNumber
	End Structure



	Friend Const LNG9_MAX					As System.Int64 = (10L) ^9L - 1L 
	Private mnMinus							As Integer
	Private mstrNum							As String

	Private mlstNum							As System.Collections.Generic.List(Of System.Int64)

	'Private mstbNum          As System.Text.StringBuilder 
	Private shared mlng10pow()				As System.Int64 


	Private mLastDivideBase					As clsStringNumber
	Private mLastDivideDivide				As clsStringNumber
	Private mLastDivideQuotient				As clsStringNumber
	Private mLastDivideRemain				As clsStringNumber

	Private Shared mblDivCheck				As Boolean
	Private Shared mblDivExceptOn			As Boolean


	Public Sub New()
		Me.mnMinus =0       '1:プラス 0:未読み込み -1:マイナス
		Me.mstrNum = Nothing
		Me.mlstNum = Nothing

		Call Me.InitModuleVars()
	End Sub

	Friend Sub New( ByVal Value As String )
		call Me.SetStringNum( Value )
		Call Me.InitModuleVars()
	End Sub
	Friend Sub New( ByVal Value As System.Int64 )
		call Me.SetLong( Value )
		Call Me.InitModuleVars()
	End Sub

	Private Sub InitModuleVars()
		
		If clsStringNumber.mlng10pow Is Nothing Then
			Call clsStringNumber.InitSharedVars()
		End If
		Call Me.ClearDivCash()
	End Sub

	Friend Shared Sub InitSharedVars()
		' 文法よく分からん。
		If clsStringNumber.mlng10pow Is Nothing Then
			clsStringNumber.mlng10pow = System.Array.CreateInstance( _
						GetType( System.Int64 ), 10 )
			clsStringNumber.mlng10pow( 0 ) = 1L
			For nCnt As Integer = 1 To 10 - 1
				clsStringNumber.mlng10pow( nCnt ) = clsStringNumber.mlng10pow( nCnt - 1 ) * 10L
			Next

		End If


		clsStringNumber.mblDivCheck = False
		clsStringNumber.mblDivExceptOn = False
	End Sub


	Friend Property StrNum() As String
	Get
  		Return  Me.mstrNum
	End Get
	Set( ByVal value As String )
  		Me.mstrNum = value
	End Set
	End Property


	Friend Property Minus() As Integer
	Get
		Return  Me.mnMinus
	End Get
	Set( ByVal value As Integer )
		Me.mnMinus = value
	End Set
	End Property




	Friend Property Lng9( ByVal nBlockNo As Integer) As System.Int64
	Get
		Return  Me.mlstNum.Item( nBlockNo )
	End Get
	Set( ByVal value As System.Int64 )
		Me.mlstNum.Item( nBlockNo ) = value
	End Set
	End Property

	Friend Property Lng9Length() As Integer
	Get
		Return  Me.mlstNum.Count 
	End Get
	Set( ByVal value As Integer )
		If Me.mlstNum Is Nothing Then
			Me.mlstNum = new _ 
			System.Collections.Generic.List(Of System.Int64)( value )

			'#warn "メモリを一度に複数用意する     "
			'#warn "GetRange と Add Range 使えばいいんじゃね？"
			'こんな感じでコピー出来ないかな

		End If

		Dim nOldCount        As Integer
		Dim nIncreaseCnt    As Integer
		Dim nAddedCnt       As Integer
		
		nOldCount = Me.mlstNum.Count
		nIncreaseCnt = value - nOldCount
		nAddedCnt = 0

		If nIncreaseCnt < 0 Then
			' RemoveRange( 開始Index, 終了Index)....じゃなかったのかコイツｗ
			' RemoveRange( 開始Index, 削除する個数 )   だったらしい。
			Me.mlstNum.RemoveRange( value, nOldCount - value )
		End If
		' わざわざ小さい配列にし直す必要性は低いのだけど・・・。
		' 無駄に大きいメモリをずっと確保され続けても迷惑？
		Me.mlstNum.Capacity = value

		Dim nLoop             As Integer
		If nIncreaseCnt < 10 Then
			nLoop = nIncreaseCnt - 1
			' System.Windows.Forms.MessageBox.Show( "nLoop is " & nLoop.ToString() )
			Call Me.Add0To10( nLoop )
			' System.Windows.Forms.MessageBox.Show( "mlstNum.Count is " & Me.mlstNum.Count.ToString() )
			Exit Property
		Else

			' #warn "%で割り算演算子あってないのでは？"
			' A / B   小数つきで除算
			' A \ B    整数で除算
			' A Mod B 剰余を計算
			nLoop = 10 + ( nIncreaseCnt Mod 10L ) - 1
			Call Me.Add0To10( nLoop )
		End If
		nAddedCnt = nLoop + 1
	
		If ( nIncreaseCnt - nAddedCnt ) = 0 Then
			Exit Property
		End If
		Dim lstAdd           As System.Collections.generic.List(Of System.Int64 )

		' 0 
		' 0 1 2 3 4 5 6 7 8 9 10 
		lstAdd = Me.mlstNum.GetRange( nOldCount, 10 ) 

		If nIncreaseCnt - nAddedCnt < 100 Then
			nLoop = ( ( nIncreaseCnt - nAddedCnt ) \ 10 ) - 1
			Call Me.AddListNTime( lstAdd, nLoop )
			nAddedCnt += ( nLoop + 1 ) * 10
			Exit Property
		Else
			nLoop = 10 + ((( nIncreaseCnt - nAddedCnt )  Mod 100 ) \ 10 ) - 1
			Call Me.AddListNTime( lstAdd, nLoop )
			nAddedCnt += ( nLoop + 1 ) * 10
		End If

		lstAdd = Me.mlstNum.GetRange( nOldCount, 100 )

		If nIncreaseCnt - nAddedCnt < 1000 Then
			nLoop = ( ( nIncreaseCnt - nAddedCnt ) \ 100 ) - 1
			Call Me.AddListNTime( lstAdd, nLoop )
			nAddedCnt += ( nLoop + 1 ) * 100
			Exit Property
		Else
			nLoop = 10 + ((( nIncreaseCnt - nAddedCnt )  Mod 1000 ) \ 100 ) - 1
			Call Me.AddListNTime( lstAdd, nLoop )
			nAddedCnt += ( nLoop + 1 ) * 100
		End If

		lstAdd = Me.mlstNum.GetRange( nOldCount, 1000 )

		If ( nIncreaseCnt - nAddedCnt ) < 10000 Then
			nLoop = ( ( nIncreaseCnt - nAddedCnt ) \ 1000 ) - 1
			Call Me.AddListNTime( lstAdd, nLoop )
			nAddedCnt += ( nLoop + 1 ) * 1000
			Exit Property
		Else
			nLoop = 10 + ((( nIncreaseCnt - nAddedCnt )  Mod 10000 ) \ 1000 ) - 1
			Call Me.AddListNTime( lstAdd, nLoop )
			nAddedCnt += ( nLoop + 1 ) * 1000
		End If


		lstAdd = Me.mlstNum.GetRange( nOldCount, 10000 )
		' あとは万ループで対応。手抜き
		'どうせ10万桁なんて使わんし
		nLoop = (( nIncreaseCnt - nAddedCnt ) \ 10000 ) - 1
		Call Me.AddListNTime( lstAdd, nLoop )

		'For nCnt As Integer = nOldCount To value - 1
		'    Me.mlstNumber.Add( 0L )
		'Next
		' 100桁で12ループ
		' 1000桁で112ループ
		' 1万桁で1112ループ
		' 100!で2千桁、224ループ
		'   何回も呼ぶのに224ループは重すぎ。
	End Set
	End Property


	Friend Shared Property DividedResultCheck() As Boolean
		Get
			Return clsStringNumber.mblDivCheck
		End Get
		Set( ByVal value As Boolean )
			clsStringNumber.mblDivCheck = value
		End Set
	End Property

	' でも0除算は無視で割り算の結果チェックだけｗ
	Public Shared Property DivideErrorException() As Boolean
		Get
			Return  clsStringNumber.mblDivExceptOn
		End Get
		Set( ByVal value As Boolean )
			clsStringNumber.mblDivExceptOn = value
		End Set
	End Property


	Private Sub Add0To10( ByVal nLoop As Integer )
		For nCnt As Integer = 0 To nLoop
		Me.mlstNum.Add( 0L )
		Next
	End Sub

	Private Sub AddListNTime( ByVal lst As  System.Collections.Generic.List(Of System.Int64),  ByVal nLoop As Integer )
		For nCnt As Integer = 0 To nLoop
		Me.mlstNum.AddRange( lst )
		Next
	End Sub

	Friend Sub SetLong( ByVal value As System.Int64 )
        Dim lngLow      As System.Int64
        Dim lngHigh     As System.Int64
        

		If Me.mlstNum Is Nothing Then
            Me.mlstNum = _ 
               new System.Collections.Generic.List(Of System.Int64)
        End If

        Me.StrNum = Nothing

		
		If value < 0 Then
			Me.mnMinus = -1

			' 0x7fff = 128(0x80) x 256 - 1 
			'      0x8000 = 25600 + 5120 + 2048 = 32768
			'      0x7fff = 32767
			' 0xffff = -1
			' 0x8000 = NOt + 1= -32768 だっけ？
			'   
			' 0x7fff = 65535 
			' 65535 * -1 = -65535
			' 0x7fff * 0xffff = 0x7ffe 8001
			' ? マイナスの最小値に-1をかけるとオーバーフローするのでは？

			If value = System.Int64.MinValue Then
				Me.Lng9Length = 3
				Me.lng9( 0 ) = ( System.Int64.MaxValue Mod ( LNG9_MAX + 1 ) ) + 1
				Dim lngTmp			As System.Int64
				lngTmp = ( System.Int64.MaxValue \ ( LNG9_MAX + 1 ) )
				Me.lng9( 1 ) =  lngTmp Mod ( LNG9_MAX + 1 ) 
				Me.lng9( 2 ) = lngTmp \ ( LNG9_MAX + 1 ) 
	            Exit Sub
			End If
         	value *= -1
		Else
			Me.Minus = 1
		End If

		lngLow = value Mod ( LNG9_MAX + 1L )
		lngHigh = value \ ( LNG9_MAX + 1L ) 

		If lngHigh > 0 Then
	        Dim lngHigh2    As System.Int64

			lngHigh2 = lngHigh \ ( LNG9_MAX + 1L )
			If lngHigh2 > 0 Then
				lngHigh = lngHigh Mod ( LNG9_MAX + 1L )
				Me.Lng9Length = 3
				Me.lng9( 0 ) = lngLow
				Me.lng9( 1 ) = lngHigh
				Me.lng9( 2 ) = lngHigh2
			Else
				Me.Lng9Length = 2
				Me.lng9( 0 ) = lngLow
				Me.lng9( 1 ) = lngHigh
			End If

		Else
			Me.Lng9Length = 1
			Me.lng9( 0 ) = lngLow
		End If
                    
    End Sub

	Friend Sub SetclsStringNumber( ByVal objBase As clsStringNumber )
		With objBase
			Call Me.ClearDivCash()
			
			Me.mnMinus = .Minus
			Me.mstrNum = .StrNum
			Me.Lng9Length = .Lng9Length
			If Me.Lng9Length > 0 Then
				For nCnt As Integer = 0 To Me.Lng9Length - 1
					Me.Lng9( nCnt ) = .Lng9( nCnt )
				Next
			End If
		End With

	End Sub
    

	' デフォルトのスイッチどうすっかな・・・。
	' どうせ俺しか使わんのだしエクセル貼り付け可能形式じゃね？
	Friend Overloads Function ToString() As String
		' コード中
		Return Me.ToString( "NMT" )
	End Function

	' sFortmat : D/d      十進数      N/n         : 3桁数ずつカンマつき10進数
	'			 DMT/dmt:            NMT/nmt     : 9桁ごとに,,が、3桁ずつにカンマ付き10進数
	'            x/X  16進数    B/W/DW/QW byte/word/doubleword/quatword 
	'              xb/xw/xdw/xqw, XB/XW/XSW/XQW
	'            EMT/emt:     Excel 貼り付け可能なタブ改行つき十進数
	'            EMTd/EMTD, EMTn/EMTN, EMTx/EMTX  :  カンマなし/3桁数ずつカンマつき/16進数(大文字/小文字)
	'                                                表記の Excel 貼り付け可能な形式
	Public Overloads Function ToString( ByVal sFormat As String ) As String
		If Me.mnMinus = 0 Then
			Me.mstrNum = ""
			Return Me.mstrNum
		End If



		Dim stb					As System.Text.StringBuilder
		Dim nBlock				As Integer
		Dim nBlockEnd			As Integer
		Dim nstbSize    		As Integer

		Dim nCommaMode			As Integer		' 0 : 一切カンマなし 1:3桁ごとのみ  2:9桁ごとのみ   3:3桁と9桁ごと
		Dim arstrFormats()		As String

		nCommaMode = 1
		With Nothing
			Dim cTop      As System.Char
			cTop = sFormat.Chars( 0 )
			
			Select Case cTop
			Case "D"C, "d"C
				arstrFormats = new String(1) { "D", "D9" }
				If sFormat.ToLower() = "dmt" Then
					nCommaMode = 2
					' ブロック1個につき x (数字9 桁 + カンマ2つ ) + -符号
					nstbSize = Me.Lng9Length * ( 9 + 2 ) + 1
				Else
					nCommaMode = 0
					' ブロック1個につき x (数字9 桁 +          ) + -符号
					nstbSize = Me.Lng9Length * ( 9 + 0 ) + 1
				End If
			Case "N"C, "n"C
				arstrFormats = new String(1) { "###,###,##0", "000,000,000" }
				If sFormat.ToLower() = "nmt" Then
					nCommaMode = 3
					' ブロック1個につき x (数字9 桁 +カンマ2つ + カンマ2つ ) + -符号
					nstbSize = Me.Lng9Length * ( 9 + 2 + 2 ) + 1
				Else
					nCommaMode = 1
					' ブロック1個につき x (数字9 桁 +カンマ2つ +          ) + -符号
					nstbSize = Me.Lng9Length * ( 9 + 2 + 0 ) + 1
				End If

			Case "x"C, "X"C
				Return Me.ToHexString( sFormat )
			Case "e"C, "E"C
				
				If sFormat.ToLower().Substring( 0, 3 ) = "emt" Then
					Return Me.ToExcelPasteString( sFormat.Substring( 3 ) )
				Else
					' 頭からやり直し。ちょっと怖い再起記述だな。GoTo 文使った方が良かったかな…。
					Return Me.ToString()
				End If

			Case Else
				nCommaMode = 0
				arstrFormats = new String(1) { "D", "D9" }
				' ブロック1個につき x (数字9 桁 +          ) + -符号
				nstbSize = Me.Lng9Length * ( 9 + 0 ) + 1

			End Select 
			
		End With

		stb = new System.Text.StringBuilder( nstbSize )
		stb.Capacity = nstbSize
		If Me.mnMinus = -1 Then
			stb.Append( "-" )
		End If
		nBlockEnd = Me.mlstNum.Count - 1
		For  nBlock = 0 To nBlockEnd
			Dim sValuesFormat     As String
			If nBlock = 0 Then
				'sValuesFormat = "D"
				sValuesFormat = arstrFormats( 0 )
			Else
				'sValuesFormat = "D9"
				sValuesFormat = arstrFormats( 1 )
				If nCommaMode = 2 Or nCommaMode = 3 Then
					stb.Append( ",," )
				ElseIf nCommaMode = 1 Then
					stb.Append( "," )
				End If
			End If
			Dim lngToString      As System.Int64
			lngToString = Me.mlstNum.Item( nBlockEnd - nBlock )
			'Console.WriteLine( "string part is """ & lngToString.ToString() & """" )
			
			stb.Append( lngToString.ToString( sValuesFormat ) )
		Next
		Me.mstrNum = stb.ToString()
		Return Me.mstrNum
	End Function


	Public Overloads Function ToHexString() As String
		Return Me.ToHexString( "xw" )
	End Function

	' x/X  16進数    X/XB/XW/XDW/XQW 連続区切り記号なし/byte/word/doubleword/quatword
	Public Overloads Function ToHexString( ByVal sFormat As String ) As String

		Dim nNumberCountOnBlock   As Integer
		Dim blBigChr              As Boolean

		Dim stb					As System.Text.StringBuilder
		Dim nstbSize    		As Integer


		blBigChr = False
		With Nothing
			

			Select Case sFormat
			Case "x"
				nNumberCountOnBlock = 0

				' Max １万桁として、元の10進数オーダーが 9 * Lng9Length
				'
				'  10^a = 16^b   a*log10 = b * log16
				'          A 桁の数は 16 進数では           log10
				'                                b = a * ---------
				'                                          log16
				'
				'  ln10 = 2.30258509299
				'  ln16 = 2.77258872223,   ln10 / ln16 = 0.83048202372
				'
				'    けんざん：  
				'            100 は a = 2, b = 1.66    2桁必要。 100=0x64
				'          1,000 は a = 3, b = 2.49    3桁必要。 1,000=0x3e8
				'         10,000 は a = 4, b = 3.32    4桁必要。 10,000=0x2710
				'        100,000 は a = 5, b = 4.15    5桁必要。  =0x1 86a0
				'      1,000,000 は a = 6, b = 4.98    5桁必要。  =0xf 4240
				'     10,000,000 は a = 7, b = 5.78    6桁必要。  =0x98 9680
				'    100,000,000 は a = 8, b = 6.64    7桁必要。  =0x5f5 e100
				' 10万桁だったら  
				'                   a = 100,000 , b=83,048.20  83,049 桁必要。
				'
				'  100,000 x 8304820 = 830,482,000,000 > Integer.MaxValue
				'                                      < Int64.MaxValue
				'                                 --->  Int64 で計算可能。
				'                               
				nstbSize = 9 * Me.Lng9Length + 1

				' ここ来てなくね？
				'Console.WriteLine( "ToHexString() ""x"" option." )
				'Console.ReadLine()

			Case "X"
				nNumberCountOnBlock = 0
				blBigChr = True
				nstbSize = 9 * Me.Lng9Length + 1
			Case "xb"
				nNumberCountOnBlock = 2
				nstbSize = ( Me.Lng9Length *  9 ) + ( ( ( ( Me.Lng9Length *  9 ) + 3 ) * 3 ) \ 2 ) + 1
			Case "XB", "xB", "Xb"
				nNumberCountOnBlock = 2
				blBigChr = True
				nstbSize = ( Me.Lng9Length *  9 ) + ( ( ( ( Me.Lng9Length *  9 ) + 3 ) * 3 ) \ 2 ) + 1
			Case "xw"
				nNumberCountOnBlock = 4
				nstbSize = ( Me.Lng9Length *  9 ) + ( ( ( ( Me.Lng9Length *  9 ) + 4 ) * 5 ) \ 4 ) + 1
			Case "XW", "xW", "Xw"
				nNumberCountOnBlock = 4
				blBigChr = True
				nstbSize = ( Me.Lng9Length *  9 ) + ( ( ( ( Me.Lng9Length *  9 ) + 4 ) * 5 ) \ 4 ) + 1
			Case "xdw"
				nNumberCountOnBlock = 8
				nstbSize = ( Me.Lng9Length *  9 ) + ( ( ( ( Me.Lng9Length *  9 ) + 8 ) * 9 ) \ 8 ) + 1
			Case "XDW", "xDW", "XdW", "XDw", "xdW", "xDw", "Xdw"
				nNumberCountOnBlock = 8
				blBigChr = True
				nstbSize = ( Me.Lng9Length *  9 ) + ( ( ( ( Me.Lng9Length *  9 ) + 8 ) * 9 ) \ 8 ) + 1
			Case "xqw"
				nNumberCountOnBlock = 16
				nstbSize = ( Me.Lng9Length *  9 ) + ( ( ( ( Me.Lng9Length *  9 ) + 16 ) * 17 ) \ 16 ) + 1
			Case "XQW", "xQW", "XqW", "XQw", "xqW", "xQw", "Xqw"
				nNumberCountOnBlock = 16
				blBigChr = True
				nstbSize = ( Me.Lng9Length *  9 ) + ( ( ( ( Me.Lng9Length *  9 ) + 16 ) * 17 ) \ 16 ) + 1
			Case Else
				nNumberCountOnBlock = 4
				nstbSize = ( Me.Lng9Length *  9 ) + ( ( ( ( Me.Lng9Length *  9 ) + 4 ) * 5 ) \ 4 ) + 1
			End Select 

			Dim lLog10Divlog16_Pow1000000		As System.Int64
			lLog10Divlog16_Pow1000000 = 8304820L
			
			Dim lstbSize		As System.Int64
			lstbSize = nstbSize * lLog10Divlog16_Pow1000000
			lstbSize /= 1000000L
			nstbSize = System.Convert.ToInt32( lstbSize  )
	
		End With


		'Console.WriteLine( "ToHexString() Loop Start option={0}.  nNumberCountOnBlock={1}", sFormat , nNumberCountOnBlock  )
		'Console.ReadLine()



		stb = new System.Text.StringBuilder( nstbSize )
		stb.Capacity = nstbSize

		With Nothing
			Dim objQuotient		As clsStringNumber
			Dim objRemain		As clsStringNumber
			Dim nOrderCount		As Integer
			Dim sToStringArg 	As String
			Dim obj16L			As clsStringNumber

			obj16L = new clsStringNumber( 16L )

			If blBigChr Then
				sToStringArg = "X"
			Else
				sToStringArg = "x"
			End If

			objQuotient = Me.Clone()

			Dim nMinus		As Integer
			If objQuotient.Minus = -1 Then
				nMinus = -1
				objQuotient.Minus = 1
			End If
			'Console.WriteLine( "ToHexString()  objQuotient={0} ", objQuotient.ToString()  )
			'Console.ReadLine()

			Do
				If objQuotient < 16L Then

					If nNumberCountOnBlock > 0 Then
						If nOrderCount = nNumberCountOnBlock Then
							stb.Insert( 0, "," )

							nOrderCount = 0
						End If
					End If

					stb.Insert( 0, objQuotient.Lng9( 0 ).ToString( sToStringArg ) )

					If nNumberCountOnBlock > 0 Then
						nOrderCount += 1
					End If
					If nNumberCountOnBlock > 0 And nOrderCount <> nNumberCountOnBlock Then
						Do
							stb.Insert( 0, "0" )

							nOrderCount += 1
							If nOrderCount = nNumberCountOnBlock Then
								Exit Do
							End If
						Loop
					End If

					'Console.WriteLine( "ToHexString()  Loop Ended option={0}.  nNumberCountOnBlock={1} stb={2}", sFormat , nNumberCountOnBlock, stb.ToString()  )
					'Console.ReadLine()
					If nMinus = -1 Then
						stb.Insert( 0, "-"C )

					End If

					Exit Do
				End If


				'Console.WriteLine( "ToHexString() Divide(Mod) Trying... objQuotient={0} objQuotient.Lng9Length={1} ", objQuotient.ToString( "N"), objQuotient.Lng9Length )
				objRemain = objQuotient Mod obj16L
				'Console.WriteLine( "ToHexString() Divide Mod Done " )

				objQuotient = objQuotient \ obj16L

				'Console.WriteLine( "ToHexString() Divide(Mod) Done... objRemain={0} objQuotient={1} ", objRemain.ToString( "N"), objQuotient.ToString() )
				'Console.ReadLine()

				'For nCnt As Integer = 0 To objQuotient.Lng9Length - 1
				'	Console.Write( "|{0}| ",objQuotient.Lng9( nCnt ).ToString( "000,000,000" ) )
				'Next
				'Console.WriteLine( "" )



				If nNumberCountOnBlock > 0 Then
					If nOrderCount = nNumberCountOnBlock Then
						stb.Insert( 0, "," )

						nOrderCount = 0
					End If
				End If

				stb.Insert( 0, objRemain.Lng9( 0 ).ToString( sToStringArg ) )

				If nNumberCountOnBlock > 0 Then
					nOrderCount += 1
				End If

					
				'Console.WriteLine( "ToHexString() Loop Continue option={0}.  nNumberCountOnBlock={1} stb={2}", sFormat , nNumberCountOnBlock, stb.ToString()  )
				'Console.ReadLine()


			Loop
		End With

		Me.mstrNum = stb.ToString()
		Return Me.mstrNum

	End Function

	Public overloads Function ToExcelPasteString() As String
		Return Me.ToExcelPasteString( "N" )
	End Function

	'		sFormat : D/N/x/X    10進数 / 3桁ごとカンマつき10進数 / 16進数(小文字) / 16進数(大文字)
	Public overloads Function ToExcelPasteString( ByVal sFormat As String ) As String
		' 複数行・列に分割ペーストするには、
		' Excel 側で右クリック > 形式を選択して貼り付け > テキスト
		' をやってもらうしかないらしい。

		' Excel のオブジェクトを保持して直接操作してしまえば良いが、
		' StringNumber の中に実装するような機能ではないな、これは。
		' すっげー不安定になりそうだし、Excel.Range オブジェクトとして実装するのは
		' やめといた方が良さそうだ。
		' 
		' https://yakumomutsuki.hatenablog.com/entry/2018/01/27/235137
		' VBA で CreateObject("Excel.Application") ....
		' などという感じで操作可能ではあるが、タイプライブラリが無いのに
		' なんで動くんだろこれ？？？


		'1	1	1
		'2	2	2
		'3	3	3
		'4	4	4

		Dim arstrFormats()		As String
		Dim blCommaExist		As Boolean
		blCommaExist = False

		With Nothing
			Dim cTop      As System.Char
			If sFormat.Length > 0 Then
				cTop = sFormat.Chars( 0 )
			Else
				cTop = "D"C
			End If
			
			Select Case cTop
			Case "D"C, "d"C
				arstrFormats = new String(1) { "D", "D9" }
			Case "N"C, "n"C
				arstrFormats = new String(1) { "###,###,##0", "000,000,000" }
				blCommaExist = True
			Case "x"C
				arstrFormats = new String(1) { "x9", "x9" }
			case "X"C
				arstrFormats = new String(1) { "X9", "X9" }
			Case Else
				arstrFormats = new String(1) { "D", "D9" }
			End Select 
			
		End With


		Dim stb					As System.Text.StringBuilder
		Dim nstbSize    		As Integer

		If blCommaExist Then
			' ブロック1個につき x (数字9 桁 + カンマ3つ + タブ) + 改行 + -符号
			nstbSize = Me.Lng9Length * ( 9 + 3 + 2 ) + (Me.Lng9Length \ 3) * (2-1)  + 1
		Else
			' ブロック1個につき x (数字9 桁  + タブ) + (改行-タブ一個分) + -符号
			nstbSize = Me.Lng9Length * ( 9 + 2 ) + (Me.Lng9Length \ 3) * (2-1)  + 1
		End If
		stb = new System.Text.StringBuilder( nstbSize )
		stb.Capacity = nstbSize

		Dim nRow  			As Integer
		nRow = 0

		Dim nBlockEnd			As Integer
		nBlockEnd = Me.Lng9Length - 1
		For nBlock As Integer = 0 To nBlockEnd


			Dim nFormatType  			As Integer
			If nBlock = 0 Then
				nFormatType = 0
			Else
				nFormatType = 1
			End If
			If nRow > 0 Then
				stb.Append( vbTab )  
			End If
			stb.Append( Me.Lng9( nBlockEnd - nBlock ).ToString( arstrFormats(nFormatType) ) )  
			If nRow = 2 Then
				stb.Append( vbCrlf )  
			End If

			nRow += 1
			If nRow = 3 Then
				nRow = 0
			End If

		Next
		If nRow > 0 Then
			Do While nRow < 2
				stb.Append( vbTab ) 
				nRow += 1
			Loop
			stb.Append( vbCrlf )
		End If

		Me.mstrNum = stb.ToString()
		Return Me.mstrNum

	End Function


	Public Sub SetClassClone( ByVal objValue As clsStringNumber )

		Me.Lng9Length = objValue.Lng9Length

		Dim nBlockEnd		As Integer
		nBlockEnd = Me.Lng9Length - 1
		For nBlock As Integer = 0 To nBlockEnd
			Me.Lng9( nBlock ) = objValue.Lng9( nBlock )
		Next
		Me.mnMinus = objValue.Minus
		Me.mstrNum = objValue.mstrNum

		Me.ClearDivCash()

	End Sub


	Public Shared Operator =( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As clsStringNumber ) As Boolean

		Dim nLng9Length		As Integer
		If (operand1.Lng9Length <> operand2.Lng9Length) Or _
			(operand1.Minus <> operand2.Minus) Or _ 
			(operand1.Lng9Length <> operand2.Lng9Length) Then
			Return False
		End If
		nLng9Length = operand1.Lng9Length
		For n As Integer = 0 To nLng9Length - 1
			If operand1.Lng9( n ) <> operand2.Lng9( n ) Then
				Return False
			End If
		Next
		Return True
	End Operator

	Public Shared Operator <>( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As clsStringNumber ) As Boolean

		Return Not (operand1 = operand2)	
	End Operator


	Public Shared Operator =( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As System.Int64 ) As Boolean

		Dim objoperand2		As clsStringNumber
		objoperand2 = new clsStringNumber( operand2 )

		Return (operand1 = objoperand2)
	End Operator
	Public Shared Operator =( ByVal operand1  As System.Int64,  _
								ByVal operand2  As clsStringNumber ) As Boolean

		Dim objoperand1		As clsStringNumber
		objoperand1 = new clsStringNumber( operand1 )

		Return (objoperand1 = operand2)
	End Operator

	Public Shared Operator <>( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As System.Int64 ) As Boolean

		Dim objoperand2		As clsStringNumber
		objoperand2 = new clsStringNumber( operand2 )

		Return (operand1 <> objoperand2)
	End Operator
	Public Shared Operator <>( ByVal operand1  As System.Int64,  _
								ByVal operand2  As clsStringNumber ) As Boolean

		Dim objoperand1		As clsStringNumber
		objoperand1 = new clsStringNumber( operand1 )

		Return (objoperand1 <> operand2)
	End Operator











	Public Shared Operator +( ByVal operand1 As clsStringNumber, _ 
  							ByVal operand2 As clsStringNumber ) As clsStringNumber
		Dim objRet		As clsStringNumber
		objRet = operand1.Clone()
		Return objRet.RetAddSNum( operand2 )
	End Operator 


	Public Shared Operator +( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As System.Int64 ) As clsStringNumber
		Dim objRet          As clsStringNumber
		Dim objOperand2     As clsStringNumber  
		
		objOperand2 = new clsStringNumber( operand2 )
		objRet = operand1 + objOperand2
				
		Return objRet
	End Operator


	Public Shared Operator -( ByVal operand1 As clsStringNumber, _ 
  							ByVal operand2 As clsStringNumber ) As clsStringNumber
		Dim objRet		As clsStringNumber
		objRet = operand1.Clone()
		Return objRet.RetSubSNum( operand2 )
	End Operator 


	Public Shared Operator -( ByVal operand1  As clsStringNumber,  _
                                ByVal operand2  As System.Int64 ) As clsStringNumber
		Dim objRet          As clsStringNumber
		Dim objOperand2     As clsStringNumber  
        
		objOperand2 = new clsStringNumber( operand2 )
        objRet = operand1 - objOperand2
             
		Return objRet
	End Operator

	Public Shared Operator \( ByVal operand1  As clsStringNumber,  _
                                ByVal operand2  As clsStringNumber ) As clsStringNumber
        Dim stDivideResult	As stDivideResult

        stDivideResult = operand1.RetDivideSNum( operand2 )
             
		Return stDivideResult.objQuotient
	End Operator

	Public Shared Operator \( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As System.Int64 ) As clsStringNumber
		Dim objOperand2       As clsStringNumber
		objOperand2 = new clsStringNumber( operand2 )
		
		Return ( operand1 \ objOperand2 )
	End Operator

	Public Shared Operator Mod( ByVal operand1  As clsStringNumber,  _
                                ByVal operand2  As clsStringNumber ) As clsStringNumber
        Dim stDivideResult	As stDivideResult

        stDivideResult = operand1.RetDivideSNum( operand2 )
             
		Return stDivideResult.objRemainder
	End Operator

	Public Shared Operator Mod( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As System.Int64 ) As clsStringNumber
		Dim objOperand2       As clsStringNumber
		objOperand2 = new clsStringNumber( operand2 )
		
		Return ( operand1 Mod objOperand2 )
	End Operator





	Public Shared Operator *(ByVal operand1 As clsStringNumber, ByVal operand2 As clsStringNumber ) As clsStringNumber
		Return operand1.RetMultiUNum( operand2 )
	End Operator

	Public Shared Operator *(ByVal operand1 As clsStringNumber, ByVal operand2 As System.Int64 ) As clsStringNumber
		Dim objOperand2			As clsStringNumber
		objOperand2 = new clsStringNumber( operand2 )

		Return ( operand1 * objOperand2 )
	End Operator
	Public Shared Operator *(ByVal operand1 As System.Int64, ByVal operand2 As clsStringNumber ) As clsStringNumber
		Return ( operand2 * Operand1 )
	End Operator



#If 0
	Public Shared Operator +=( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As clsStringNumber ) As clsStringNumber

		objRet = operand1 + objOperand2
		Return objRet
	End Operator
	Public Shared Operator +=( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As System.Int64 ) As clsStringNumber
		Dim objRet          As clsStringNumber
		Dim objOperand2     As clsStringNumber  
		
		objOperand2 = new clsStringNumber( operand2 )
		objRet = operand1 +  objOperand2
			
		Return objRet
	End Operator

	Public Shared Operator -=( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As clsStringNumber ) As clsStringNumber

		objRet = operand1 - objOperand2
		Return objRet
	End Operator
	Public Shared Operator -=( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As System.Int64 ) As clsStringNumber
		Dim objRet          As clsStringNumber
		Dim objOperand2     As clsStringNumber  
		
		objOperand2 = new clsStringNumber( operand2 )
		objRet = operand1 - objOperand2
				
		Return objRet
	End Operator
#End If

	Public Shared Operator >( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As clsStringNumber ) As Boolean
		Dim bRet       As Boolean

		If operand2.Minus = -1 Then
			If operand1.Minus = 1 Then
				bRet = True
			ElseIf operand1.CompareUNum( operand2 ) < 0 Then
				bRet = True
			Else
				bRet = False
			End If
     	Else
          
			If operand1.Minus = -1 Then
				bRet = False
			ElseIf operand1.CompareUNum( operand2 ) > 0 Then
				bRet = True
			Else
				bRet = False
			End If
		End If
		Return bRet
	End Operator

	Public Shared Operator <( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As clsStringNumber ) As Boolean
		Dim bRet       As Boolean

		If operand2.Minus = -1 Then
			If operand1.Minus = 1 Then
				bRet = False
			ElseIf operand1.CompareUNum( operand2 ) > 0 Then
				bRet = True
			Else
				bRet = False
			End If
		Else
			
			If operand1.Minus = -1 Then
				bRet = True
			ElseIf operand1.CompareUNum( operand2 ) < 0 Then
				bRet = True
			Else
				bRet = False
			End If
		End If
		Return bRet
	End Operator


	Public Shared Operator >( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As System .Int64 ) As Boolean
		Dim objOperand2       As clsStringNumber
		objOperand2 = new clsStringNumber( operand2 )
		Dim bRet       As Boolean
        
		bRet = ( operand1 > objOperand2 )

		Return bRet
	End Operator

	Public Shared Operator <( ByVal operand1 As clsStringNumber,  _
								ByVal operand2 As System.Int64 ) As Boolean
		Dim objOperand2       As clsStringNumber
		objOperand2 = new clsStringNumber( operand2 )

		Return ( operand1 < objOperand2 )
	End Operator






	Public Shared Operator <=( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As clsStringNumber ) As Boolean
		Dim bRet       As Boolean

		bRet = ( operand1 > operand2 )
		bRet = Not bRet

		Return bRet
	End Operator


	Public Shared Operator >=( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As clsStringNumber ) As Boolean
		Dim bRet       As Boolean

		bRet = ( operand1 < operand2 )
		bRet = Not bRet

		Return bRet
	End Operator


	Public Shared Operator <=( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As System.Int64 ) As Boolean
		Dim objOperand2       As clsStringNumber
		objOperand2 = new clsStringNumber( operand2 )

		Return ( operand1 <= objOperand2 )
	End Operator

    
	Public Shared Operator >=( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As System.Int64 ) As Boolean
		Dim objOperand2       As clsStringNumber
		objOperand2 = new clsStringNumber( operand2 )

		Return ( operand1 >= objOperand2 )
	End Operator

＃If 0
	Public Shared Operator *=( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As clsStringNumber ) As clsStringNumber
			Return ( operand1 * objOperand2 )
	End Operator

	Public Shared Operator *=( ByVal operand1  As clsStringNumber,  _
								ByVal operand2  As System.Int64 ) As Boolean
		Dim objOperand2       As clsStringNumber
		objOperand2 = new clsStringNumber( operand2 )

		Return ( operand1 * objOperand2 )
	End Operator
#End If



	Friend Function RetAddSNum( ByVal other As clsStringNumber ) As clsStringNumber
	  	Dim objRet        As clsStringNumber 
		If Me.mnMinus = 1 Then
			If other.Minus = 1 Then
				objRet = Me.CalcAddedUNum( other )
			Else
				objRet = Me.CalcSubUNum( other )
			End If
		Else
			If other.Minus = 1 Then
				objRet = other.CalcSubUNum( Me )

				' -1+1= -0 となってしまう対策
				If objRet.IsZero() = True Then
					objRet.Minus = 1
				End If
			Else
				objRet = Me.CalcAddedUNum( other )
				objRet.Minus = -1
			End If
		  End If
	  	Return objRet
	End Function


	Friend Function RetSubSNum( ByVal other As clsStringNumber ) As clsStringNumber
		Dim objRet			As clsStringNumber 
	  	If Me.mnMinus = 1 Then
			If other.Minus = 1 Then
				objRet = Me.CalcSubUNum( other )
			Else
				objRet = Me.CalcAddedUNum( other )
			End If
		Else
			If other.Minus = 1 Then
				objRet = Me.CalcAddedUNum( other )
			Else
				objRet = Me.CalcSubUNum( other )
				If objRet.IsZero() = True Then
					objRet.Minus = 1
				Else
					objRet.Minus *= -1
				End If
			End If
		End If
		Return objRet
	End Function




	' iniRW.vb で保存出来るように改造して、とにかく保存出来るように。
	' XXX,XXX,XXX,,XXX,XXX,XXX,,XXX,XXX,XXX,,XXX,XXX,XXX,,
	' XXX,XXX,XXX,,XXX,XXX,XXX,,XXX,XXX,XXX,,XXX,XXX,XXX,,
	' 改行も対応してエクセルに貼り付け保存出来るようにしないと。
	'
	' Excel に張り付けやすいデータは以下。
	' エクセル上で形式を選択して貼り付け、にし、テキストにすれば
	' マルチカラム貼り付けが出来る。
	'1		2		3		4	
	'1		2		3		4	
	'1		2		3		4	
	' 将来的には上記みたいな感じのデータフォーマットにせんといかんね。

	' List<type> 使うなら GetEnumerator で書き直さないといかんね。
	' System.Array で配列化する方が正しいっぽいけど、
	' 追加削除もするからどっちもどっちだなぁ。
	' List<type> は恐らく固定長配列を使ってるから、アクセス速度は
	' そんな極端には変わらんはず。
	' System.array の方がもちろん早いけど、そこまで高速化する
	' 必要は恐らく無いだろう。

	Friend Function SetStringNum( ByRef other As String ) As Boolean

		' Console.WriteLine( "other is """ & other & """" )

		' .netframeworkに読ませた方が良くないか？
		other = other.Trim( " " )
		If other.Length <= 9 Then
			Dim lngRead			As System.Int64
			Dim bRet			As Boolean

			bRet = System.Int64.TryParse( other, lngRead )
			If bRet Then
				Call Me.SetLong( lngRead )
				Me.mstrNum = other
			End If
			Return bRet
		End If
		Dim nMinus       As Integer
		nMinus = 0
		With Nothing
			Dim nEnd			As Long
			Dim nReadCnt		As Integer
			Dim lngRead			As Long
			Dim lng10Pow		As Long
			'nEnd = other.Chars.Length - 1
			' Length プロパティまんまでいいのかな？？？
			nEnd = other.Length - 1
			nReadCnt = 0
			lng10Pow= 1
			lngRead = 0

			' 高速化を優先して自分で配列管理
			' 何しろここ来る機会多いし。
			With Nothing
				Dim nBlockCount		As Integer

				nBlockCount = ( nEnd \ 9 ) + 1
				If Me.mlstNum IsNot Nothing Then
					' Me.Lng9Length = ( nEnd \ 9 ) + 1
					'If Me.mlstNum.Count > nBlockCount Then
					'	Me.mlstNum.RemoveRange( nBlockCount, Me.mlstNum.Count - 1 )
					'End If
					Me.mlstNum.Clear()

				Else
					Me.mlstNum = _ 
							new System.Collections.Generic.List(Of System.Int64)
				End If
				Me.mlstNum.Capacity = nBlockCount + 1
			End With

			For n As Integer = 0 To nEnd
				Dim c      As System.Char
				Dim nCNum       As Long
				c = other.Chars(nEnd - n)

				If ( n = nEnd ) And ( c = "-"C ) Then
					nMinus = -1
					Exit For   
				ElseIf System.Char.IsDigit( c ) = False Then
					'Call clsPub.ErrMsg( _
					'	new System.Diagnostics.StackTrace( true ) , _ 
					'	" 数字が読めない！ other = " & other )
					Me.mstrNum = other
					Me.mnMinus = nMinus
					Return False
				End If
				' switch 文で実装するのが一応は正しいらしい。
				'Select Case c
				'Case "0"c
				'  nCNum = 0
				'Case "9"c
				'  nCNum = 9
				'End Select
				nCNum = System.Convert.ToInt64( c ) - _ 
							System.Convert.ToInt64( "0"C )
				lngRead += nCnum * lng10Pow

				lng10Pow *= 10
				nReadCnt +=1
				nMinus = 1
				If nReadCnt >= 9 Then

					Me.mlstNum.Add( lngRead )
					lngRead = 0
					lng10Pow = 1
					nReadCnt = 0
				End If
			Next

			If nReadCnt > 0 Then
				Me.mlstNum.Add( lngRead )
			End If

		End With

		If Me.IsZero() Then
			nMinus = 1
		End If

		Me.mnMinus = nMinus
		Me.mstrNum = other

		Return True
	End Function




	Friend Function SetStringNum2( ByRef strNumber As String ) As Boolean
		Dim sHead       As String
		
		Dim nHeadLength      As Integer
		If strNumber.Length < 20 Then
			sHead = strNumber
			nHeadLength = strNumber.Length - 1
		Else
			sHead = strNumber.Substring( 0, 20 )
			nHeadLength = 20 - 1
		End If
		Dim blIsHex                 As Boolean
		Dim nCntStart               As Integer
		Dim bMinus                  As Integer
		blIsHex = False
		bMinus = False

		Do	' GoTo 代用 Do～Loop
			If  sHead.Chars( 0 ) = "-"C Then
				nCntStart = 1
				bMinus = True
			Else
				nCntStart = 0
			End If

			If ( sHead.Length - nCntStart ) >= 3 Then 
				If ( ( sHead.Chars( nCntStart ) = "0" ) And (sHead.Chars( nCntStart + 1 ) ="x") ) Or _ 
					( ( sHead.Chars( nCntStart ) = "&" ) And _ 
							( (sHead.Chars( nCntStart + 1 ) ="h") Or (sHead.Chars( nCntStart + 1 ) ="H") ) ) _ 
							Then
					blIsHex = True
					nCntStart += 2
					Exit Do
				End If
			End If

			Exit Do
		Loop
		Dim nNumOrderMax            As Integer
		Dim blSingleCommaMust       As Boolean
		Dim blSingleCommaNG         As Boolean
		Dim blDoubleComma           As Boolean
		blSingleCommaMust = False
		blSingleCommaNG = False
		blDoubleComma = False
		nNumOrderMax = -1
		If sHead.IndexOf( ",,", 1 ) >= 1 Then
			blDoubleComma = True
		End If
		Dim nPos			As Integer

		nPos = sHead.IndexOf( ",", nCntStart )
		If nPos < 0 Then

			' 数字部分が "0X" だったら 16進数扱い
			
			Do	' Goto 文代用 Do～Loop

				If blDoubleComma = True Then
					Exit Do
				End If

				' カンマなしでっかいのは数字かhex扱い
				If sHead.Length > ( 16 + nCntStart ) And sHead.Length < strNumber.Length Then
					' 一切カンマなしで先頭が0でもなく、長い・・・
					' 10進数扱いでいいんじゃないの？

					For nCnt As Integer = nCntStart To sHead.Length - 1
						Dim c			As System.Char
						Dim lngRead		As System.Int64
						Dim bRet		As Boolean

						c = sHead.Chars( nCnt )
						bRet = Me.ParseHexFormat_HexChrToLong( c, lngRead )
						If bRet = False Then
							Return False
						End If
						If lngRead >= 10L Then
							blIsHex = True
							Exit For
						End If
					Next

					If blIsHex = False Then
						' "d" 
						blSingleCommaNG = True
					End If
					Exit Do
				End If

				' 数字部分のサイズが byte/word/dword/qword 桁ピッタリで頭が 0 だったら
				' 16 進数扱いｗ
				With Nothing
					Dim nNumberLength			As Integer
					nNumberLength = sHead.Length - nCntStart
					If nNumberLength = 2 Or nNumberLength = 4 Or nNumberLength = 8 Or nNumberLength = 16 Then
						If sHead.Chars( nCntStart ) = "0"C Then
							blIsHex = True
							nNumOrderMax = nNumberLength
							Exit Do
						End If
					End If
				End With

				For nCnt As Integer = nCntStart To sHead.Length - 1
					Dim c			As System.Char
					Dim lngRead		As System.Int64
					Dim bRet		As Boolean

					c = sHead.Chars( nCnt )
					bRet = Me.ParseHexFormat_HexChrToLong( c, lngRead )
					If bRet = False Then
						Return False
					End If
					If lngRead >= 10L Then
						blIsHex = True
						Exit For
					End If
				Next

				If blIsHex = True Then
					Exit Do
				End If

				' "d" 
				blSingleCommaNG = True

				
				Exit Do
			Loop

		Else


			Dim nPosNumTop        As Integer
			Dim nPosNumEnd        As Integer
			nPosNumTop = nPos + 1
			If nPosNumTop < sHead.Length - 1 Then
				If sHead.Chars( nPosNumTop ) = ","C Then
					nPosNumTop = nPosNumTop + 1
					If nPos >= sHead.Length Then
						Return False
					End If
				End If
			Else
				Return False
			End If

			Do   ' Goto 代用のDo-Loop
				' "1234567812345678,123"   0 16
				' "-1234567812345678,12"   1 17
				' "-0x1234567812345678,"   
				If  nPos - nCntStart = 16 Then
					nNumOrderMax = 16
					blIsHex = True
					Exit Do
				End If


				nPosNumEnd = sHead.IndexOf( ",", nPosNumTop )
				
				If nPosNumEnd < 0 Then

					' ""-123456789,,123456789" ~> sHead = "-123456789,,12345678"
					If sHead.Chars( 0 ) = "-" And blDoubleComma = True And sHead.Length = 20 Then
						blSingleCommaMust = False
						blSingleCommaNG = False
						Exit Do
					End If

					nPosNumEnd = sHead.Length - 1
				Else
					nPosNumEnd -= 1 
				End If
									
				Dim nOrder			As Integer
				' 01234
				' ab,cd     nOrder = 4 - 3 + 1
				' 0123456 
				' 12,345,   nOrder = 5 - 3 + 1
				nOrder = nPosNumEnd - nPosNumTop + 1


				If nOrder = 2 Or nOrder = 4 Or nOrder = 8 Or _ 
						nOrder = 16 Then
					' フォーマット確定
					nNumOrderMax = nOrder
					blIsHex = True

				ElseIf nOrder = 3 Then
					' "n","nmt"
					blSingleCommaMust = True
				ElseIf nOrder = 9 Then
					' "dmt"
					blSingleCommaMust = False
					blSingleCommaNG = True
				End If

				Exit Do
			Loop



		End If
		' ジャンプ用Do/Loop
		Do
			If blIsHex =True And nNumOrderMax <> -1 Then
				' xb/xw/xdw/xqw
				Exit Do
			End If
			If blSingleCommaMust = True Then
				' dmt
				Exit Do
			End If
			If blSingleCommaMust = False And blSingleCommaNG = True Then
				' n/nmt
				Exit Do
			End If
			' dかxかの判別
			For nCnt As Integer = nCntStart to nHeadLength
				Dim c       As System.Char
				c = sHead.Chars( nCnt ) 
				If ( c >= "a"C And c <= "f"C ) Or _ 
					( c >= "A"C And c <= "F"C ) Then
					blIsHex = True
					Exit For
				End If
			Next
			
			Exit Do
		Loop


		'Console.WriteLine( "SetStringNum2 : blIsHex={0} . sHead={1}, nNumOrderMax={2} blDoubleComma={3} blSingleCommaMust={4} blSingleCommaNG={5} .", _ 
		'		blIsHex.ToString(), sHead, nNumOrderMax, blDoubleComma, blSingleCommaMust, blSingleCommaNG  )
		If blIsHex Then
			' x/xb/xw/xdw/xqw
			Return Me.ParseHexFormat( strNumber, nCntStart, nNumOrderMax )
		End If
		If blDoubleComma = True Then
			If blSingleCommaMust = True And blSingleCommaNG = False Then
				' nmt
				Return Me.ParseTripleCommaFormat( strNumber )
			Else
				' dmt
				Return Me.ParseDoubleCommaFormat( strNumber )
			End If
		End If
		If blSingleCommaMust = True And blSingleCommaNG = False Then
			' n
			Return Me.ParseSingleCommaFormat( strNumber )
		Else
			' d
			Return Me.ParseNoCommaFormat( strNumber )
		End If
	End Function
	Friend Function ParseHexFormat( ByRef strNumber As String, ByVal nHexStartPos As Integer, ByVal nOrder As Integer ) As Boolean
		Dim objHexBase          As clsStringNumber
		Dim l10Order            As Integer  
		With Nothing
			Dim lPow       As System.Int64
			' 10 ^ x = 16 ^ y
			'
			' x * ln(10) = y * ln(16)
			'            ln(16)
			' x = y * ------------ = y * 1.2041199826
			'            ln(10)
			Select Case nOrder
			Case -1
				lPow = 4294967296L
				' 1 文字で　hex 1 桁
				l10Order = strNumber.Length * 120412L
				l10Order \= 10000L
			Case 2
				lPow = 256L
				' 3 文字で　hex 2 桁
				l10Order = strNumber.Length * 120412L * 2L
				l10Order \= 10000L * 3L
			Case 4
				lPow = 65536L
				' 5 文字で　hex 4 桁
				l10Order = strNumber.Length * 120412L * 4L
				l10Order \= 10000L * 5L
			Case 8
				lPow = 4294967296L
				' 9 文字で　hex 8 桁
				' 17 文字で　hex 16 桁
				l10Order = strNumber.Length * 120412L * 8L
				l10Order \= 10000L * 9L
			Case 16
				lPow = 4294967296L
				l10Order = strNumber.Length * 120412L * 16L
				l10Order \= 10000L * 17L
			End Select
			objHexBase = new clsStringNumber( lPow )
			If nOrder = -1 Or nOrder = 16 Then
				objHexBase *= objHexBase
			End If
		End With

		Dim blMinus         As Boolean
		blMinus = False
		If strNumber.Chars( 0 ) = "-"C Then
			blMinus = True
		End If


		If ( strNumber.Length - nHexStartPos ) <=15 Then
			Dim nIndex           As Integer
			
			'Call clsPub.ErrMsg( _
			'				new System.Diagnostics.StackTrace( true ) , _ 
			'				"ParseHexFormat : strNumber=""" & strNumber & """, nHexStartPos=" & nHexStartPos.ToString() & _ 
			'				", nIndex=" & nIndex.ToString() )

			
			nIndex = strNumber.IndexOf( ",", nHexStartPos )
			If nIndex < 0 Then
			
				Dim lngRead         As System.Int64
				Dim bRet            As Boolean

				' しまった・・・以下ルーチン内で "-" と "0x"/"&h" の処理やっちゃ駄目なんだ。
				' 外側でフォローせんといかんかったのに入れちまったよｗ外さないとｗ
				bRet = Me.ParseHexFormat_Int64TryParse( strNumber, nHexStartPos, lngRead )
				If bRet Then
					Call Me.SetLong( lngRead )
					Me.mstrNum = strNumber
					If blMinus = True And Me.IsZero() = False Then
						Me.mnMinus = -1
					Else
						Me.mnMinus = 1
					End If

					Return True
				Else
					Return False
				End If
			End If
		ElseIf ( strNumber.Length - nHexStartPos ) = 16 Then
			Dim nIndex           As Integer
			nIndex = strNumber.IndexOf( ",", nHexStartPos )
			If nIndex < 0 Then
				Dim objRead     As clsStringNumber
				objRead = new clsStringNumber()
				Dim bRet            As Boolean
				bRet = Me.ParseHexFormat_16Chr( strNumber, nHexStartPos, objRead ) 
				If bRet = False Then
					Return False
				End If
				Me.SetClassClone( objRead )
				If blMinus = True And Me.IsZero() = False Then
					Me.mnMinus = -1
				Else
					Me.mnMinus = 1
				End If

				Return True
			End If
		End If
		Dim nPos            As Integer
		nPos = nHexStartPos


		Dim objResult       As clsStringNumber
		' 引数なしで初期化すると 0 じゃなくて null がmlstNumに設定されるらしいｗ
		' どうすっかな～～～～。使いずらいけどほっとくか・・・。
		'objResult = new clsStringNumber()
		objResult = new clsStringNumber( 0L )
		
		Do
			' String.Split を使えばかなりコード量減らせるけど・・・。
			' 最終的にどんくらい RAM 使うか分からんしなぁ。
			' 現状だと桁切り圧縮機の可能性考えると、でっかい RAM はやたら
			' 使えない・・・かな？
			' 桁切り圧縮機は8Mbyte とかを想定してんのかな？？？
			Dim strToken            As String
			Dim nIndex              As Integer
			'nIndex = strNumber.IndexOf( ",", nPos )
			' nIndex は,または次の16個さすようにする！
			If nOrder = -1 Then
				' 01234567890123456 
				' abcdabcdabcdabcdABCD..... 
				nIndex = nPos + 16
			Else
				nIndex = nPos + nOrder
			End If
			If nIndex > strNumber.Length - 1 Then
				' 01234
				' ab,cd
				' 01234567890123456
				' abcdef01,cdef0123
				nIndex = strNumber.Length
			End If
		
			strToken = strNumber.SubString( nPos, nIndex - nPos )

			'Console.WriteLine( "ParseHexFormat :strNumber=""{0}"", strToken=""{1}"", nPos={2}, nIndex={3}, nOrder={4} ", strNumber, strToken, nPos, nIndex, nOrder  )

			Dim bRet            As Boolean
			Dim objRead         As clsStringNumber
			objRead = new clsStringNumber()
			'Console.WriteLine( "ParseHexFormat Before ParseHexFormat_16Chr : strToken ={0} nIndex={1} ", strToken, nIndex.ToString() )
			If ( nOrder = -1 And strToken.Length = 16 ) Or nOrder = 16 Then
				bRet = Me.ParseHexFormat_16Chr( strToken, 0, objRead ) 
			Else
				Dim lngRead             As System.Int64
				lngRead = 0
				bRet = Me.ParseHexFormat_Int64TryParse( strToken, 0, lngRead )
				If bRet Then
					objRead.SetLong( lngRead )
				End If
			End If
			'Console.WriteLine( "ParseHexFormat After ParseHexFormat_16Chr : bRet ={0} ", bRet.ToString() )
			If bRet = False Then
				Return False
			End If
			'Console.WriteLine( "ParseHexFormat : objResult = {0}, objHexBase={1}, objRead={2}. ", objResult.ToString(), objHexBase.ToString(), objRead.ToString() )
			If nOrder = -1 And strToken.Length < 16 Then
				objHexBase.SetLong( 16L ^( strToken.Length ) )
			End If
			objResult *= objHexBase
			objResult += objRead
			' *****  Will Fix? *****
			If nIndex = strNumber.Length Then
				Exit Do
			End If
			If nOrder = -1 Then
				nPos = nIndex
			Else
				nPos = nIndex + 1
			End If
			
		Loop
		
		Call Me.SetClassClone( objResult )
		If blMinus = True Or objResult.IsZero() = True Then
			Me.mnMinus = -1
		Else
			Me.mnMinus = 1
		End If
		Return True
	End Function


	Private Function ParseHexFormat_16Chr( ByRef strNumber As String, ByVal nStrParseStartPos As Integer, ByRef objRead As clsStringNumber ) As Boolean
		' 16桁16進数読込専用 
		Dim lngRead         As System.Int64
		Dim bRet            As Boolean
		Dim blTopZero        As Boolean



		bRet = Me.ParseHexFormat_HexChrToLong( strNumber.Chars( nStrParseStartPos ), lngRead )
		If Not bRet Then
			Return False
		End If
		' 0x1000 0000  0000 0000 =  65536^2 * 65536 * (256*16)   = 1,152,921,504,606,846,976
		' 0x0100 0000  0000 0000 =  65536^2 * 65536 * (256*16)   =    72,057,594,037,927,936
		' 下の9 桁 x lngRead をまず足す
		Dim obj8Hex         As clsStringNumber
		obj8Hex = new clsStringNumber( &h1000000000000000L )
		obj8Hex *= lngRead
		objRead = obj8Hex
		blTopZero = False
		' 1,,152,921,504,,606,846,976

		' objRead.Lng9Length = 2
		bRet = Me.ParseHexFormat_Int64TryParse( strNumber, nStrParseStartPos + 1, lngRead )
		If Not bRet Then
			Return False
		End If


		Dim lAddItem_0            As System.Int64
		Dim lAddItem_1            As System.Int64
		Dim lAddItem_2            As System.Int64


		lAddItem_0 = lngRead Mod ( LNG9_MAX + 1L )
		' objRead.Lng9( 0 ) = lAddItem
		lngRead \= LNG9_MAX + 1L
		lAddItem_1 = lngRead Mod ( LNG9_MAX + 1L )
		lAddItem_2 = lngRead \ ( LNG9_MAX + 1L )
		
		If blTopZero = True Then

			If objRead Is Nothing Then 
				objRead = new clsStringNumber()
			Else
				objRead.SetLong( 0 )
			End If
			If lAddItem_2 <> 0 Then
				objRead.Lng9Length = 3
				objRead.Lng9( 2 ) = lAddItem_2
				objRead.Lng9( 1 ) = lAddItem_1
				objRead.Lng9( 0 ) = lAddItem_0
			ElseIf lAddItem_1 <> 0 Then
				objRead.Lng9Length = 2
				objRead.Lng9( 1 ) = lAddItem_1
				objRead.Lng9( 0 ) = lAddItem_0
			Else
				objRead.Lng9Length = 1
				objRead.Lng9( 0 ) = lAddItem_0
			End If

		Else
			Dim objAdd           As clsStringNumber
			objAdd = new clsStringNumber( ) 

			If lAddItem_2 <> 0 Then
				objAdd.Lng9Length = 3
				objAdd.Lng9( 2 ) = lAddItem_2
				objAdd.Lng9( 1 ) = lAddItem_1
				objAdd.Lng9( 0 ) = lAddItem_0
			ElseIf lAddItem_1 <> 0 Then
				objAdd.Lng9Length = 2
				objAdd.Lng9( 1 ) = lAddItem_1
				objAdd.Lng9( 0 ) = lAddItem_0
			Else
				objAdd.Lng9Length = 1
				objAdd.Lng9( 0 ) = lAddItem_0
			End If
			objAdd.Minus = 1

			'Call clsPub.ErrMsg( _
			'				new System.Diagnostics.StackTrace( true ) , _ 
			'				"ParseHexFormat_16Chr : objAdd=""" & objAdd.ToString() & """, objRead=""" & objRead.ToString() & _ 
			'				""", objAdd.Minus=" & objAdd.Minus.ToString() )

			objRead += objAdd

		End If
		

		Return True
	End Function


	' 8 文字までのHex > Int64 変換
	' ..... にしようと思ったが、15文字までにしとこｗ
	Friend Function ParseHexFormat_Int64TryParse( ByRef strHex8Chr As String, ByVal nStrParseStartPos As Integer, ByRef lngReaded As System.Int64 ) As Boolean
	#If 0
		' https://learn.microsoft.com/ja-jp/dotnet/api/system.int64.tryparse?view=netframework-3.5
		' をVB.Net 用に改造
		'private static void CallTryParse(string stringToConvert, NumberStyles styles)
		'CultureInfo provider;
		Dim provider            As System.Globalization.CultureInfo 
		' https://learn.microsoft.com/ja-jp/openspecs/windows_protocols/ms-lcid/a9eac961-e77d-41a6-90a5-ce1a8b0cdb9c
		' "ja" だとTryParseで実行時エラーが出る。ja-JPだと大丈夫。
		' Windows NT3.5.1 以降対応の方が動くとか訳分からん。というかこれどう考えても32bitコードで
		' 古過ぎるだろ…。オール自作の方が安全そうだなｗ
		' アセンブリで手作りした方がx64世代命令使えるから早くなってんじゃねーの？ｗ
		'cutureInfo = new System.Globalization.CultureInfo( "ja")
		provider = new System.Globalization.CultureInfo( "ja-JP")
		'// If currency symbol is allowed, use en-US culture.
		'if ((styles & NumberStyles.AllowCurrencySymbol) > 0)
		'   provider = new CultureInfo("en-US");
		'else
		'   provider = CultureInfo.InvariantCulture;
		Dim styles      As System.Globalization.NumberStyles
		' 空白は許可したくないんだけど・・・まぁいいか。
		styles = System.Globalization.NumberStyles.HexNumber
		'bool success = Int64.TryParse(stringToConvert, styles,
		'                           provider, out long number);
		'if (success)
		'   Console.WriteLine($"Converted '{stringToConvert}' to {number}.");
		'else
		'   Console.WriteLine($"Attempted conversion of '{stringToConvert}' failed.");
		Dim bRet            As Boolean
		bRet = System.Int64.TryParse( strNumber, styles, provider, lngReaded )
		Return bRet
	#EndIf
		' なんか強烈に遅そうだなコレ・・・。
		' だいたい、数字を通し番号のコード振ってねぇ言語に対応とかバカだろｗ




		Dim c                   As System.Char
		Dim lReadValue          As System.Int64
		Dim bRet                As Boolean
		Dim nCntStart			As Integer

		nCntStart = nStrParseStartPos

		Dim nLength			       		   As Integer
		nLength = 15
		If ( strHex8Chr.Length - nCntStart ) < nLength Then
			nLength = strHex8Chr.Length - nCntStart
		End If
		Dim nLength_Minus1					As Integer
		nLength_Minus1 = nLength - 1 + nCntStart

		'Console.WriteLine( "ParseHexFormat_Int64TryParse : strHex8Chr=""{0}"", nCntStart={1}, nLength_Minus1={2} ", _
		'					 strHex8Chr, nCntStart, nLength_Minus1 )

		lngReaded = 0
		For nCnt As Integer = nCntStart To nLength_Minus1
			c = strHex8Chr.Chars( nCnt )
			bRet = ParseHexFormat_HexChrToLong( c, lReadValue )
			If bRet = False Then
				Return False
			End If
			lngReaded *= 16
			lngReaded += lReadValue
		Next

		'Console.WriteLine( "ParseHexFormat_Int64TryParse End: strHex8Chr=""{0}"", lngReaded={1} ", _
		'					 strHex8Chr, lngReaded )

		Return True
	End Function
	Friend Function ParseHexFormat_HexChrToLong( ByVal cChr As System.Char, ByRef lngReaded As System.Int64 ) As Boolean
		Select Case cChr
		Case "0"C
			lngReaded = 0
		Case "1"C
			lngReaded = 1
		Case "2"C
			lngReaded = 2
		Case "3"C
			lngReaded = 3
		Case "4"C
			lngReaded = 4
		Case "5"C
			lngReaded = 5
		Case "6"C
			lngReaded = 6
		Case "7"C
			lngReaded = 7
		Case "8"C
			lngReaded = 8
		Case "9"C
			lngReaded = 9
		Case "a"C, "A"C
			lngReaded = 10
		Case "b"C, "B"C
			lngReaded = 11
		Case "c"C, "C"C
			lngReaded = 12
		Case "d"C, "D"C
			lngReaded = 13
		Case "e"C, "E"C
			lngReaded = 14
		Case "f"C, "F"C
			lngReaded = 15
		Case Else
			Return False
		End Select
			
		Return True
	End Function
	Friend Function ParseTripleCommaFormat( ByRef strNumber As String ) As Boolean
		Dim bMinus         As Boolean
		bMinus = False
		With Nothing
			Dim nBlock       As Integer
			Dim nIndex       As Integer
			nBlock = 0
			nIndex = 0
			Do
				nIndex = strNumber.IndexOf( ",,", nIndex ) 
				If nIndex < 0 Then
					Exit Do
				End If
				nBlock += 1
				nIndex += 2
			Loop
			Me.Lng9Length = nBlock + 1
			Dim nPos                As Integer
			Dim nStartPos			As Integer
			nPos = 0
			nStartPos = 0
			nBlock = 0
			bMinus = False
			If strNumber.Chars( 0 ) ="-"C Then
				bMinus = True
				nStartPos = 1
				nPos = 1
			End If
			Do
				nIndex = strNumber.IndexOf( ",,", nPos ) 
				If nIndex < 0 Then
					'           11      19
					' 01234567890123456789            
					' 123456789,,123456789
					nIndex = strNumber.Length
				End If
				Dim strBlock      As String
				Dim lngBlock       As System.Int64 
				lngBlock = 0
				' 012,456,89a,, 
				strBlock = strNumber.Substring( nPos, nIndex - nPos )
				Dim nChrEnd       As Integer
				Dim nChrComma1    As Integer
				Dim nChrComma2    As Integer
				If nPos  = nStartPos Then
					If strBlock.Length <= 3 Then 
						nChrEnd = strBlock.Length - 1
						nChrComma1 = -1
						nChrComma2 = -1
					ElseIf strBlock.Length <= 7 Then
						nChrEnd = strBlock.Length - 1
						nChrComma1 = strBlock.Length - 4
						nChrComma2 = -1
					Else
						nChrEnd = strBlock.Length - 1
						nChrComma1 = strBlock.Length - 8
						nChrComma2 = strBlock.Length - 4
					End If
				Else
					nChrComma1 = 3
					nChrComma2 = 7
					nChrEnd = 11 - 1
					If strBlock.Length <> nChrEnd + 1 Then
						Return False
					End If
				End If
				'Console.WriteLine( "ParseTripleCommaFormat : strNumber=""{0}"", nPos={1}, nIndex={2}, strBlock=""{3}"", nChrEnd={4} ", _ 
				'						strNumber, nPos, nIndex, strBlock, nChrEnd )
				For nChr As Integer = 0 To nChrEnd
					Dim bRet          As Boolean
					Dim lngRead       As System.Int64
					If nChr = nChrComma1 Or nChr = nChrComma2 Then
						If strBlock.Chars( nChr ) = ","C Then
							Continue For
						Else
							Return False
						End If
					End If
					bRet = ParseHexFormat_HexChrToLong( strBlock.Chars( nChr ), lngRead ) 
					If bRet  = False Or lngRead >= 10L Then
						Return False
					End If
					lngBlock *= 10
					lngBlock += lngRead
				Next
				Me.Lng9( Me.Lng9Length - 1 - nBlock ) = lngBlock
				If nIndex = strNumber.Length Then
					Exit Do
				End If
				nBlock += 1
				nPos  = nIndex + 2
			Loop
		End With
		If bMinus = False Or Me.IsZero() = True Then
			Me.mnMinus = 1
		Else
			Me.mnMinus = -1
		End If
		Me.MstrNum = strNumber.Clone()
		Call Me.ClearDivCash()

		'Console.WriteLine( "ParseTripleCommaFormat Returns true." )
		Return True
	End Function
	Friend Function ParseDoubleCommaFormat( ByRef strNumber As String ) As Boolean
		Dim bMinus         As Boolean
		bMinus = False
		With Nothing
			Dim nBlock       As Integer
			Dim nIndex       As Integer
			nBlock = 0
			nIndex = 0
			Do
				nIndex = strNumber.IndexOf( ",,", nIndex ) 
				If nIndex < 0 Then
					Exit Do
				End If
				nBlock += 1
				nIndex += 2
			Loop
			Me.Lng9Length = nBlock + 1
			Dim nPos                As Integer
			nPos = 0
			nBlock = 0
			If strNumber.Chars( 0 ) ="-"C Then
				bMinus = True
				nPos = 1
			End If
			Do
				nIndex = strNumber.IndexOf( ",,", nPos ) 
				If nIndex < 0 Then
					nIndex = strNumber.Length
				End If
				Dim strBlock      As String
				Dim lngBlock       As System.Int64 
				lngBlock = 0
				' 012345678
				strBlock = strNumber.Substring( nPos, nIndex - nPos )
				Dim nChrEnd       As Integer

				nChrEnd = strBlock.Length - 1
				If nBlock = 0 And ( nChrEnd + 1 ) > 9 Then
					Return False
				ElseIf nBlock > 0 And ( nChrEnd + 1 ) <> 9 Then
					Return False
				End If
				
				For nChr As Integer = 0 To nChrEnd
					Dim bRet          As Boolean
					Dim lngRead       As System.Int64
					bRet = ParseHexFormat_HexChrToLong( strBlock.Chars( nChr ), lngRead ) 
					If bRet  = False Or lngRead >= 10L Then
						Return False
					End If
					lngBlock *= 10
					lngBlock += lngRead
				Next
				Me.Lng9( Me.Lng9Length - 1 - nBlock ) = lngBlock
				If nIndex = strNumber.Length Then
					Exit Do
				End If
				nBlock += 1
				nPos  = nIndex + 2
			Loop
		End With
		If bMinus = False Or Me.IsZero() = True Then
			Me.mnMinus = 1
		Else
			Me.mnMinus = -1
		End If
		Me.MstrNum = strNumber
		Call Me.ClearDivCash()
		Return True
	End Function
	Friend Function ParseSingleCommaFormat( ByRef strNumber As String ) As Boolean
		Dim bMinus         As Boolean
		bMinus = False
		With Nothing
			Dim nPos                As Integer
			Dim nCntStart			As Integer
			nPos = 0
			If strNumber.Chars( 0 ) ="-"C Then
				bMinus = True
				nPos = 1
				nCntStart = 1
			End If


			' ,000,000,000  12文字
			' 文字数 \ 12     +1 = 12 ブロック数 a
			' 文字数 Mod 12  = 先頭ブロックの文字数 b
			' b \ 4  = カンマの数
			' ba987654321 
			' 000,000,000
			' b Mod 4  = 先頭3桁の桁数
			'  b <= 3   b   先頭ブロックの桁数
			'  elseif b <= 7   b - 1   
			'  elseif b <= 11  b - 2 
			Dim nBlock                    As Integer
			nBlock = ( ( strNumber.Length - nCntStart ) \ 12 ) + 1
			Me.Lng9Length = nBlock
			Dim nTopBlockChrLength        As Integer
			nTopBlockChrLength = ( strNumber.Length - nCntStart ) Mod 12

			Select Case nTopBlockChrLength
			Case 1,2,3
				' 1 12 123
			Case 5,6,7
				' 1,xxx 12,xxx 123,xxx
			Case 9,10,11
				' 1,xxx,xxx 12,xxx,xxx 123,xxx,xxx
			Case Else
				Return False
			End Select

			Dim nIndex                As Integer
			nIndex = 0
			nBlock = 0

			Do
				'Console.WriteLine( "ParseSingleCommaFormat Do Loop Top: strNumber=""{0}"", nCntStart=""{1}"", nPos={2} ", _
				'					strNumber, nCntStart, nPos )

				'nIndex = strNumber.IndexOf( ",", nPos ) 
				If nPos = nCntStart Then
					nIndex = nCntStart + nTopBlockChrLength
				Else
					' 012,345,678,9ab
					nIndex = nPos + 11
				End If
				If nIndex >= strNumber.Length + 1 Then
					Return False
				ElseIf nIndex < strNumber.Length Then
					If strNumber.Chars( nIndex ) <> ","C Then

						'Console.WriteLine( "ParseSingleCommaFormat Return False : nIndex=""{0}"", strNumber.Length=""{1}"", strNumber=""{2}"" ", _
						'			nIndex, strNumber.Length, strNumber )
						Return False
					End If
				End If
				

				Dim strBlock      As String
				Dim lngBlock       As System.Int64 
				lngBlock = 0
				' 012,456,89a, 
				strBlock = strNumber.Substring( nPos, nIndex - nPos )

				If nPos <> nCntStart Then
					If strBlock.Length <> 11 Then
						Return False
					End If
				End If

				'Console.WriteLine( "ParseSingleCommaFormat : strNumber=""{0}"", strBlock=""{1}"", nPos={2}, nIndex={3} ", _
				'					strNumber, strBlock, nPos, nIndex    )

				Dim nChrEnd       As Integer
				Dim nChrComma1    As Integer
				Dim nChrComma2    As Integer
				If nPos  = nCntStart Then
					If strBlock.Length <= 3 Then 
						nChrEnd = strBlock.Length - 1
						nChrComma1 = -1
						nChrComma2 = -1
					ElseIf strBlock.Length <= 7 Then
						nChrEnd = strBlock.Length - 1
						nChrComma1 = strBlock.Length - 4
						nChrComma2 = -1
					Else
						nChrEnd = strBlock.Length - 1
						nChrComma1 = strBlock.Length - 8
						nChrComma2 = strBlock.Length - 4
					End If
				Else
					nChrComma1 = 3
					nChrComma2 = 7
					nChrEnd = 10
				End If
				For nChr As Integer  = 0 To nChrEnd
					Dim bRet          As Boolean
					Dim lngRead       As System.Int64
					If nChr = nChrComma1 Or nChr = nChrComma2 Then
						If strBlock.Chars( nChr ) = ","C Then
							Continue For
						Else
							Return False
						End If
					End If
					bRet = ParseHexFormat_HexChrToLong( strBlock.Chars( nChr ), lngRead ) 
					If bRet  = False Or lngRead >= 10L Then
						Return False
					End If
					lngBlock *= 10
					lngBlock += lngRead
				Next
				Me.Lng9( Me.Lng9Length - 1 - nBlock ) = lngBlock
				If nIndex = strNumber.Length Then
					Exit Do
				End If
				nBlock += 1
				nPos  = nIndex + 1
			Loop
		End With
		If bMinus = False Or Me.IsZero() = True Then
			Me.mnMinus = 1
		Else
			Me.mnMinus = -1
		End If
		Me.MstrNum = strNumber
		Call Me.ClearDivCash()
		Return True
	End Function
	Friend Function ParseNoCommaFormat( ByRef strNumber As String ) As Boolean
		Return Me.SetStringNum( strNumber )
	End Function


	' Me - other 0:=  1:Me>other -1:Me<other 
	Friend Function CompareUNum( ByVal other As clsStringNumber ) As Integer

		If Me.Lng9Length = other.Lng9Length Then
	   
			Dim n                          As Integer
			Dim nLng9Length       As Integer
			nLng9Length = Me.Lng9Length

			n = nLng9Length - 1
			Do
				Dim lngMe           As System.Int64
				Dim lngother        As System.Int64
				lngMe = Me.Lng9( n )
				lngother = other.Lng9( n )
				If lngMe = lngother Then
					n -= 1
					If n < 0 Then
						Return 0
					End If
				ElseIf lngMe > lngother Then
					Return 1
				Else
					Return -1
				End If
			Loop
		ElseIf Me.Lng9Length > other.Lng9Length Then
			Return 1
		Else
			Return -1
		End If 
	
	End Function

	Friend Function IsZero() As Boolean
		If Me.mlstNum.Count > 1 Then
			Return False
		ElseIf Me.mlstNum.Item( 0 ) <> 0 Then
			Return False
		End If
		Return True
	End Function


	'引き算、ただし me-otherで双方正を仮定
	Friend Function CalcSubUNum( ByVal other As clsStringNumber ) As clsStringNumber
		Dim objRet		As clsStringNumber
		Dim objSub		As clsStringNumber
		Dim nMinus		As Integer
	  
		Select Case Me.CompareUNum( other )
		Case -1
			objRet = other.Clone()
			objSub = Me
			nMinus = -1
		Case 0
			objRet = new clsStringNumber()
			objRet.Lng9Length = 1
			objRet.Lng9( 0 ) = 0
			objRet.Minus = 1
			Return objRet
		Case Else
		' Case 1
			objRet = Me.Clone()
			objSub = other
			nMinus = 1
		End Select

		'  9999     29    2 
		'-      1       1    1 
		Dim nBlock				As Integer
		Dim nSubLng9Length		As Integer

		nBlock = 0
		nSubLng9Length = objSub.Lng9Length
		Do While nBlock < nSubLng9Length
			Dim lngSub        As System.Int64

			lngSub = objRet.Lng9( nBlock )
			lngSub -= objSub.Lng9( nBlock )
			If lngSub >= 0 Then
				objRet.Lng9( nBlock ) = lngSub
			Else
				lngSub += LNG9_MAX + 1
				objRet.Lng9( nBlock ) = lngSub
				Dim nBlock2        As Integer
				nBlock2 = nBlock + 1

				Do
					If objRet.Lng9( nBlock2 )= 0 Then
						objRet.Lng9( nBlock2 )= LNG9_MAX
						nBlock2 += 1
					Else 
						objRet.Lng9( nBlock2 ) -= 1
						Exit Do
					End If
				Loop
	 		  End If
		
			nBlock += 1
		Loop

		Call objRet.CutZeroBlock() 

		' Console.WriteLine( "objRet.Minus is : " & objRet.Minus.ToString() )
		objRet.Minus = nMinus

	  	'コード適当だけどこれで動くんじゃね？
	  	Return objRet
  	End Function

  	Friend Sub CutZeroBlock()
		Dim nBlock       As Integer
		With Me
			If .mlstNum Is Nothing Then
				Return
			End If
			nBlock = .mlstNum.Count - 1
			Do while nBlock > 0
				If .mlstNum.Item( nBlock ) > 0 Then
					Exit Do
				End If
				nBlock -= 1
			Loop
			If nBlock = .mlstNum.Count - 1 Then
				Return
			End If

			Dim nBlock2      As Integer
			nBlock2 = .mlstNum.Count - 1
			Do While nBlock2 > nBlock
				.mlstNum.RemoveAt( nBlock2 )
				nBlock2 -= 1
			Loop
			.mlstNum.Capacity = nBlock + 1
		End With
  	End Sub

	Friend Function CalcAddedUNum( ByVal other As clsStringNumber ) As clsStringNumber
		Dim objRet			As clsStringNumber
		Dim objAdd			As clsStringNumber
   
		If Me.Lng9Length < other.Lng9Length Then
			objRet = other.Clone()
			objAdd = Me
		Else
			objRet = Me.Clone()
			objAdd = other
		End If


		'  9999     29    2 
		'+     1       1    1 
		Dim nBlock                        As Integer
		Dim nAddLng9Length       As Integer

		nBlock = 0
		'Console.WriteLine( "nAddLng9Length is " & nAddLng9Length.ToString() )
		nAddLng9Length = objAdd.Lng9Length
		Do While nBlock < nAddLng9Length
			Dim lngAdd        As System.Int64

			lngAdd = objRet.Lng9( nBlock )
			'Console.WriteLine( "lngAdd  <= objRet  : {" & lngAdd.ToString() & "}" )
			lngAdd += objAdd.Lng9( nBlock )
			'Console.WriteLine( "lngAdd  <= +objAdd : {" & lngAdd.ToString() & "}" )
			'Console.WriteLine( "LNG9_MAX           : {" & LNG9_MAX.ToString() & "}" )
			If lngAdd <= LNG9_MAX Then
				objRet.Lng9( nBlock ) = lngAdd
			Else
				lngAdd -= LNG9_MAX + 1
				objRet.Lng9( nBlock ) = lngAdd
				Dim nBlock2        As Integer
				nBlock2 = nBlock + 1
				 

		 		Do
					If objRet.Lng9Length <= nBlock2 Then
						objRet.Lng9Length += 1
						objRet.Lng9( nBlock2 ) = 1
						Exit Do
					ElseIf objRet.Lng9( nBlock2 )= LNG9_MAX  Then
						objRet.Lng9( nBlock2 )= 0
						nBlock2 += 1
					Else 
						objRet.Lng9( nBlock2 ) += 1
						Exit Do
					End If
	  
		 		Loop
			End If
		
		nBlock += 1
	  Loop
	  Return objRet
  End Function


	' 割り算
	' 1234 / 34 
	' 1


	' 掛け算
	Friend Function RetMultiUNum( ByVal other As clsStringNumber ) As clsStringNumber

		'    1000   =10^3
		'  x  100    =10^2
		' = 10^5
		'     999
		' x    99
		'= 98901
		'  9桁 x 9桁
		'  10^9 ～ 10^10-1 : 
		Dim objRet        As clsStringNumber
		objRet = new clsStringNumber( 0 ) 
		objRet.Lng9Length = Me.Lng9Length + other.Lng9Length

		With Nothing
		Dim nBase             As Integer
		Dim nBaseEnd       As Integer
		Dim nMulti            As Integer
		Dim nMultiEnd       As Integer

		nBaseEnd =Me.Lng9Length - 1
		nMultiEnd =other.Lng9Length - 1

		For nBase = 0 To nBaseEnd

			If Me.mlstNum.Item( nBase ) = 0L Then
				Continue For
			End If

		For nMulti = 0 To nMultiEnd
			Dim lngMulti       As System.Int64


			If other.Lng9( nMulti ) = 0L Then
				Continue For
			End If

			lngMulti = Me.mlstNum.Item( nBase ) * _
					other.Lng9( nMulti )

			Dim lngLow      As System.Int64
		Dim lngHigh     As System.Int64
			
			lngLow = lngMulti Mod ( LNG9_MAX + 1 )
		lngHigh = lngMulti \ ( LNG9_MAX + 1 ) 

			Call objRet.RetMultiUNum_Add1Block( lngLow, nBase + nMulti )
			Call objRet.RetMultiUNum_Add1Block( lngHigh, nBase + nMulti + 1  ) 
		Next
		Next
		End With

		Call objRet.CutZeroBlock()
		
		objRet.Minus = Me.Minus * other.Minus

		Return objRet

	End Function

	Friend Sub RetMultiUNum_Add1Block( ByVal lngBlocked As Integer , ByVal nPos As Integer  )
		Dim lngAdded     As System.Int64
		lngAdded = Me.mlstNum.Item( nPos ) + lngBlocked

		If lngAdded <= LNG9_MAX Then
			Me.mlstNum.Item( nPos ) = lngAdded
		Else
			lngAdded  -= LNG9_MAX + 1
			Me.mlstNum.Item( nPos ) = lngAdded

			Dim nBlock      As Integer
			nBlock = nPos + 1
			Do
				If Me.mlstNum.Item( nBlock ) = LNG9_MAX Then
				Me.mlstNum.Item( nBlock ) = 0
				nBlock += 1
				Else
				Me.mlstNum.Item( nBlock ) += 1
				Exit Do
				End If
			Loop
		End If

	End Sub



	Friend Function RetLShiftLng9( ByVal nBlockCount As Integer ) As clsStringNumber

		Dim objRet			As clsStringNumber
		Dim nBlockCntEnd	As Integer

		If nBlockCount = 0 Then
			Return Me.Clone()
		End If

		objRet = new clsStringNumber()
		objRet.Lng9Length = Me.Lng9Length + nBlockCount

		Dim nBlock       AS Integer

		nBlockCntEnd = Me.Lng9Length - 1
		For nBlock = 0 To nBlockCntEnd
			objRet.Lng9(  nBlockCount + nBlock ) = _ 
				Me.Lng9( nBlock )
		Next

		objRet.Minus = Me.Minus
		
		Return objRet
	End Function

	Friend Function RetRShiftLng9( ByVal nBlockCount As Integer ) As clsStringNumber
		Dim objRet          As clsStringNumber
		Dim nBlockCntEnd    As Integer
		If nBlockCount = 0 Then
			Return Me.Clone()
		End If
		objRet = new clsStringNumber()
		objRet.Lng9Length = Me.Lng9Length - nBlockCount
		Dim nBlock       AS Integer
		nBlockCntEnd = objRet.Lng9Length - 1
		For nBlock = 0 To nBlockCntEnd
			objRet.Lng9( nBlock ) = _ 
				Me.Lng9( nBlock +  nBlockCount )
		Next
		objRet.Minus = Me.Minus
		
		Return objRet
	End Function





  	Friend Function Clone() As clsStringNumber
		Dim objRet				As clsStringNumber
		objRet = new clsStringNumber()
		With objRet
			.StrNum = Me.StrNum
			.Minus = Me.Minus

			Dim nLng9Length     As Integer
			nLng9Length = Me.Lng9Length
			.Lng9Length = nLng9Length

			If nLng9Length > 0 Then
				For nCnt = 0 To nLng9Length - 1


					Try
						.Lng9( nCnt ) = Me.Lng9( nCnt )
					Catch err as System.ArgumentOutOfRangeException
						Console.WriteLine( "Clone failed . nLng9Length={0}, objRet.Lng9Length={1} . ", _ 
									nLng9Length, objRet.Lng9Length )
						THrow err
					End Try
				Next 
			End If
		End with
		Return  objRet
		
	End Function



	Private Sub ErrMsg( ByVal StackTrace as System.Diagnostics.StackTrace, _ 
						 ByVal sErrMsg As String, _ 
						Optional ByVal sErrMsg2 As String = "", _
						Optional ByVal sErrMsg3 As String = "", _
						Optional ByVal sErrMsg4 As String = "" )
		If sErrMsg2 <> "" Then      sErrMsg &= VbCrlf & sErrMsg2
		If sErrMsg3 <> "" Then      sErrMsg &= VbCrlf & sErrMsg3
		If sErrMsg4 <> "" Then      sErrMsg &= VbCrlf & sErrMsg4
		Dim stackframes() as System.Diagnostics.StackFrame
		Dim stackframe  as System.Diagnostics.StackFrame
		stackframes = StackTrace.GetFrames()
		stackframe = stackframes( 0 )
		
		Dim strFrames   as String
		strFrames = ""
		For Each stackframe In stackframes
			strFrames &= Vbcrlf & stackframe.GetFileName() & " : " & _
								 stackframe.GetFileLineNumber()
								
		Next
		'System.Windows.Forms.MessageBox.Show( sErrMsg & VbCrlf & _
		'       stackframe.GetFileName() & " : " & _
		'       stackframe.GetFileLineNumber().ToString()  )
		
		
		System.Windows.Forms.MessageBox.Show( sErrMsg & VbCrlf & _
				strFrames  )
	End Sub


End Class






End NameSpace
