
Option Explicit On

NameSpace CalcCn

Friend Partial Class clsStringNumber






	Friend ReadOnly Property IsDivideCashed( ByVal objBase As clsStringNumber, ByVal objDivide  As clsStringNumber ) As Boolean
	Get
		If Me.mLastDivideBase Is Nothing Or _ 
			Me.mLastDivideDivide Is Nothing  Then
			Return False
		End If

		Dim bRet       As Boolean
		If Me.mLastDivideBase = objBase And _ 
			Me.mLastDivideDivide = objDivide  Then
			bRet = True
		Else
			bRet = False 
		End If
		Return bRet
	End Get
	End Property

	Friend Sub ClearDivCash()
		Me.mLastDivideBase = Nothing
		Me.mLastDivideDivide = Nothing
		Me.mLastDivideQuotient = Nothing
		Me.mLastDivideRemain = Nothing
	End Sub



	Friend Function RetDivideSNum( ByVal objDivide As clsStringNumber ) As stDivideResult

		Dim stRet           As stDivideResult

		If Me.IsDivideCashed( Me, objDivide ) Then
			stRet.objQuotient = Me.mLastDivideQuotient
			stRet.objRemainder = Me.mLastDivideRemain

			'Console.WriteLine( "Cash hit! : objQuotient = {0}, objRemainder = {1}", stRet.objQuotient.ToString(), stRet.objRemainder.ToString() )

			Return stRet
		End If

		Dim nMeMinus        As Integer
		Dim nDivideMinus    As Integer

		nMeMinus = Me.Minus
		nDivideMinus = objDivide.Minus
		
		Me.Minus = 1
		objDivide.Minus = 1
		
		stRet = Me.RetDivideUNum( objDivide )
		' 余りが負の場合の動作はたぶんANSIとかで定義
		' されているはずだが、とりあえずテキトー。

		' 元に戻す
		Me.Minus = nMeMinus
		objDivide.Minus = nDivideMinus
		
		Dim nMinusRet     As Integer
		nMinusRet = nMeMinus * nDivideMinus
		
		If stRet.objQuotient.IsZero() Then
			stRet.objQuotient.Minus = 1
		Else
			stRet.objQuotient.Minus = nMinusRet
		End If
		




		' 2022/09/06
		' https://docs.microsoft.com/ja-jp/dotnet/csharp/language-reference/operators/arithmetic-operators#remainder-operator-
		'
		'	整数の剰余
		'	整数型のオペランドの場合、a % b の結果は a - (a / b) * b で生成される値になります。 0 以外の剰余の符号は、次の例で示されるように、左側のオペランドの符号と同じになります。
		'
		'	実行
		'	Console.WriteLine(5 % 4);   // output: 1
		'	Console.WriteLine(5 % -4);  // output: 1
		'	Console.WriteLine(-5 % 4);  // output: -1
		'	Console.WriteLine(-5 % -4); // output: -1

		' とりあえず、割る数がマイナスのときは余りは絶対マイナスになるように
		' コードしとく。VB.Net に合わせたいけど仕様が分からん。
		If stRet.objRemainder.IsZero() = False Then
			stRet.objRemainder.Minus = nMeMinus
		End If
		
		' キャッシュを更新
		Me.mLastDivideBase = Me.Clone()
		Me.mLastDivideDivide = objDivide.Clone()
		Me.mLastDivideQuotient = stRet.objQuotient.Clone()
		Me.mLastDivideRemain = stRet.objRemainder.Clone()

		Return stRet

	End Function


	Friend Function RetDivideUNum( ByVal objDivide As clsStringNumber ) As stDivideResult 
		Dim stRet           As stDivideResult
		' new 必要だったっけ？
		If Me.IsZero() Then
			stRet.objQuotient = new clsStringNumber( 0L )
			stRet.objRemainder = new clsStringNumber( 0L )
			Return stRet
		End If
		If objDivide.IsZero() Then

			If clsStringNumber.mblDivExceptOn Then
				Dim objException			As System.ArithmeticException
				objException = new System.DivideByZeroException()
				Throw objException
			End If
			Call clsPub.ErrMsg( _
						new System.Diagnostics.StackTrace( true ) , _ 
				" 割る数がゼロです！Me = " & Me.ToString() )
			
			Return Nothing
		End If
		Select Case Me.CompareUNum( objDivide )
		Case -1
			stRet.objQuotient = new clsStringNumber( 0L )
			stRet.objRemainder = Me.Clone()
			Return stRet
		Case 0
			stRet.objQuotient = new clsStringNumber( 1L )
			stRet.objRemainder = new clsStringNumber( 0L )
			Return stRet
		Case Else
			' 何もしない
		End Select
		Dim nBlock              As Integer
		Dim nBlockEnd           As Integer
		Dim objQuotient         As clsStringNumber
		Dim objRemain           As clsStringNumber
		nBlock = 0
		nBlockEnd = Me.Lng9Length
		objQuotient = new clsStringNumber( 0L )
		'If Me.Lng9Length - objDivide.Lng9Length + 1 >= 1 Then
		'	objQuotient.Lng9Length = Me.Lng9Length - objDivide.Lng9Length + 1
		'End If
		objRemain = Me.Clone()
		' 思いつきｗでコーディングｗ
		
		Dim bRet        As Boolean
		' 違うブロック間で割り算
		bRet = Me.RetDivideUNum_DivideByTopBlock( _ 
								objRemain:= objRemain, _ 
								objDivide:= objDivide, _ 
						objQuotient:= objQuotient )
		If bRet = True Then
			stRet.objQuotient = objQuotient
			stRet.objRemainder = objRemain
			Return stRet
		End If


		Dim objQuotient2ndpProcess		As clsStringNumber 
		Dim objRemain2ndpProcess		As clsStringNumber 

		objQuotient2ndpProcess = new clsStringNumber( 0L )
		objRemain2ndpProcess = new clsStringNumber( 0L )



		' Console.WriteLine( "RetDivideUNum :  2nd process,  objRemain={0}, objDivide={1} ", objRemain.ToString(), objDivide.ToString() )

		Call Me.RetDivideUNum_DivideBySameBlockOrder( _ 
						objRemain:= objRemain, _ 
						objDivide:= objDivide, _ 
						objQuotientResult:= objQuotient2ndpProcess, _ 
						objRemainResult := objRemain2ndpProcess )

		stRet.objQuotient = objQuotient + objQuotient2ndpProcess
		stRet.objRemainder = objRemain2ndpProcess


		' 追加コード、値チェック
		If clsStringNumber.mblDivCheck Then
			Dim objRemainRestored			As clsStringNumber

			objRemainRestored = stRet.objQuotient * objDivide + stRet.objRemainder
			If Me <> objRemainRestored Then

				Dim sErrMsg						As String

				' DivideByZeroException 
				' ArithmeticException
				'  これでいいのかな？？？ｗ

				If clsStringNumber.mblDivExceptOn Then

					sErrMsg = "Program Error! clsStringNumber RetDivideNum : divide function returns incorrect remain&Quotient. In divide operation, the restored value from remain and quotient is not the base dividied value. This is occured from divide program logic's out-case pettern. Sorry, please need to Fix code divide function! " _ 
								& " Me : " & Me.ToString() & ", divide : " & objDivide.ToString() & _ 
								", Quotient : " & stRet.objQuotient.ToString() & ", remain : " & stRet.objRemainder.ToString()

					Dim objException			As System.ArithmeticException
					objException = new System.ArithmeticException( sErrMsg )
					Throw objException
				End If

					sErrMsg = "Program Error! clsStringNumber RetDivideNum : 割り算検算したら間違ってたよ。プログラム作り込み不足だぁ！ " _ 
						& " Me : " & Me.ToString() & ", divide : " & objDivide.ToString() & _ 
						", Quotient : " & stRet.objQuotient.ToString() & ", remain : " & stRet.objRemainder.ToString()
				
				Call clsPub.ErrMsg( _
						new System.Diagnostics.StackTrace( true ) , _ 
					 	sErrMsg )

			End If
		End If


		Return stRet

	End Function


	Friend Function RetDivideUNum_DivideByTopBlock( ByRef objRemain As clsStringNumber, ByVal objDivide As clsStringNumber, ByRef objQuotient As clsStringNumber ) As Boolean
		' 思いつきｗでコーディングｗ

		' 20桁以上の数で割るには：
		' 先頭ブロック同士で割り算を行い仮の商を出す。
		'これを暫定の商とする。
		' 
		'      aa bb cc dd        aa \ AA =XX  で仮数を出す。
		' ÷       AA BB CC         α・AA + TempRemain = aa
		'-----------------          
		'         XX                   
		' 
		'    99,99,99 / 1,01 の試算:
		'          99,99,99
		'       ÷      1,01      α= 99 \ 2 = 49 mod 1
		'
		'      ( 99,99,99 ) - 49*(1,01)* 10^2 = ( 99,99,99 ) - ( 49,49,00 ) = (50,50,99)
		'      ( 50,50,99 ) \ (1,01) * 10^2   = ( 50,50,99 ) \ (1,01,00)    = 50 mod 99
		'
		'    よって XX = X1 + X2 = 49+50=99
		'
		'   (123456789 123456789)　÷ (9 123456789) = 13,531,799       mod  5,669,523,378
		'                      A1              B1            C1                       D1
		'   (123456789 123456789)  ÷ (9 000000000) = 13,717,421       mod 　 123,456,789
		'                      A2              B2            C2                       D2
		'
		'         C2*B1 = 125,150,297,750,021,169
		'             これは A1 より大きい(大小は場合場合によって異なる)。
		'         C2*B1 - A1 = 1,693,508,626,564,380
		'          (C2*B1 - A1)      / B1 = 185.621.378  <== 『　C1-C2 に偶然等しいｗ　』
		'
		'           上記２つの誤差：C1-C2              =  185,622
		'                  B1 * C1 +D1 = A1
		'                  B2 * C2 +D2 = A2
		'


		'   (C2*B1 - A1) / B1 = C2 - (A1/B1) 
		'                   = C2 - ( C1 + D1/B1 )  
		'                       
		'       よって   C1 = C2 - (C2*B1 - A1) / B1
		'   (C2*B1 - A1)は求める事が簡単に出来るが、
		'      (C2*B1 - A1) / B1 は処理的に不可能である。
		'      そこで、(C2*B1 - A1) /B1 を求める処理を
		'       再帰的に新たに開始する。
		'           (C2*B1 - A1) \   B1    = C3    Mod  D3 
		'           (C2*B1 - A1) \   B2    = C4    Mod  D4
		'
		'         C4 * B1 - (C2*B1 - A1) =   
		
		'                               原理はよく分からんが、ショートカット的計算が可能らしい。
		'               
		' ようやく：
		' 最上位ブロック同士で割り算。
		' 出た商は最大で50%の誤差を含むがほっとく。
		'      




		' Q' = lngRemain /( 1 + α ) 
		' objDivide =  A1 * 10^9n  +  A2 * 10^9(n-1) +  A3 * 10^9(n-2) + ....
		'             1                 A2 
		'   α =   ------  ・ -----------
		'             A1            10^9
		' 
		'   B1・C1=B2・C2
		'    B1=B2・(1+α)
		'   C1・(1+α)=C2
		'   Q' = lngRemain / ( 1 + α )
		'                            A1 * 10^9
		'       = lngRemain  ・　-------------------
		'                         A1 * 10^9 + A2
		'            1                      (A1 00 00)
		'    β =  ------- * (01 00)  =    --------------
		'           1+ α                       (A1 A2)
	
		' 上記 β = objBeta = 1/(α+1)を求める
		Dim objBeta          As clsStringNumber

		With Nothing
			' objDivideの先頭、A1 の先頭の値と桁を求める

			With Nothing
				Dim blA2LowIsZero		As Boolean
				blA2LowIsZero = False
				If objDivide.Lng9Length = 1 Then
					blA2LowIsZero = True
				Else
					If objDivide.Lng9( objDivide.Lng9Length -2 ) = 0L Then
						blA2LowIsZero = True
					End If
				End If
				
				If blA2LowIsZero = True Then
					objBeta = new clsStringNumber( LNG9_MAX + 1L )
					GoTo RetDivideUNum_DivideByTopBlock_BETADICIDED
				End If
			End With

			Dim objA1SNum       As clsStringNumber
			objA1SNum = new clsStringNumber( 0L )
			objA1SNum = objA1SNum.RetLShiftLng9( 1 )
			objA1SNum.Lng9( 1 ) = objDivide.Lng9( objDivide.Lng9Length -1 )
			Dim objA1A2SNum     As clsStringNumber
			With Nothing
				Dim lngA2       As System.Int64
				If objDivide.Lng9Length > 1 Then
					lngA2 = objDivide.Lng9( objDivide.Lng9Length - 2 )
				Else
					lngA2 = 0
				End If
				objA1A2SNum = objA1SNum  + lngA2
			End With
			' 少数使えないので1ブロック大きくしとく
			objA1SNum = objA1SNum.RetLShiftLng9( 1 )

			Dim nA1A2Num                 As Integer
			Dim nA1A2Num2nd              As Integer
			Dim nA1A2Order               As Integer
			Call Me.RetDivideUNum_DivideBlock1_TopNumInf( _
						objA1A2SNum.Lng9( objA1A2SNum.Lng9Length -1 ), _ 
						nA1A2Num, nA1A2Num2nd, _ 
						nA1A2Order )



			' TargetOrder がごっちゃ
			' １桁ずつ計算すればいいけどやり方が良く分からん。

			' objA1SNum \ objA1A2SNum を力技で出す
				
			Dim objBetaRemain    As clsStringNumber
			objBetaRemain = objA1SNum.Clone()
			objBeta = new clsStringNumber( 0L )
			For nOrder As Integer = 0 To 8

				' 値次第でループは中断出来る。
			
			
				'            1                      (A1 00 00)
				'    β =  ------- * (01 00)  =    --------------
				'           1+ α                       (A1 A2)
			
				Dim nBetaRemainNum      As Integer
				Dim nBetaRemainNum2nd   As Integer
				Dim nBetaRemainOrder    As Integer
				Call Me.RetDivideUNum_DivideBlock1_TopNumInf( _
						objBetaRemain.Lng9( objBetaRemain.Lng9Length - 1 ), _ 
						nBetaRemainNum, nBetaRemainNum2nd, _ 
						nBetaRemainOrder )
				If objBetaRemain.Lng9Length = 3 Then
					nBetaRemainOrder += 9
				End If


				If nBetaRemainNum <= nA1A2Num And nBetaRemainOrder > 0 Then
					nBetaRemainNum *= 10
					nBetaRemainNum += nBetaRemainNum2nd
					nBetaRemainOrder -= 1
				End If


				Dim blnA1A2Num2ndUsed			As Boolean

				blnA1A2Num2ndUsed = False
				' 実効割る数
				Dim nA1A2NumEffective			As Integer
				' 実効商のの桁
				Dim nA1A2OrderEffective			As Integer
				
				If nBetaRemainOrder < nA1A2Order Then
					nA1A2NumEffective = 10 * nA1A2Num + nA1A2Num2nd
					nA1A2OrderEffective = nA1A2Order - 1
					blnA1A2Num2ndUsed = True
				Else
					nA1A2NumEffective = nA1A2Num
					nA1A2OrderEffective = nA1A2Order
				End If

				Dim nTargetOrder				As Integer
				nTargetOrder = nBetaRemainOrder - nA1A2OrderEffective

				'Console.WriteLine( "RetDivideUNum_DivideByTopBlock BetaDivide : objBetaRemain={0}, nBetaRemainNum={1},nA1A2Num={2}  ", _ 
				'											objBetaRemain.ToString(), nBetaRemainNum, nA1A2Num )
				'Console.ReadLine()


				Dim nTopDiv    As Integer
				nTopDiv = nBetaRemainNum \ nA1A2NumEffective
				' 割る数の2桁目の補正をする
				If blnA1A2Num2ndUsed = False Then
					If nA1A2Num > 0 Then
						nTopDiv *= 10 * nA1A2Num
						nTopDiv \= 10 * nA1A2Num + nA1A2Num2nd
						If nTopDiv = 0 Then
							nTopDiv = 1
						End If
					End If
				End If

				Dim objDivOrder				As clsStringNumber
				objDivOrder = new clsStringNumber( clsStringNumber.mlng10pow( nTargetOrder Mod 9 ) )
				With Nothing
					Dim nBlockShift		As Integer
					nBlockShift = nTargetOrder \ 9
					If nBlockShift > 0 Then
						objDivOrder = objDivOrder.RetLShiftLng9( 1 )
					End If
				End With
				Dim objDivBase				As clsStringNumber
				objDivBase = objDivOrder * objA1A2SNum
				Dim objDivMultied			As clsStringNumber
				objDivMultied = objDivBase * System.Convert.ToInt64( nTopDiv )

				Dim objBetaRemainTmp		As clsStringNumber

				objBetaRemainTmp = objBetaRemain - objDivMultied
				
				If (objBetaRemainTmp.Minus = -1 And nTopDiv = 1 ) Or _ 
					( nTopDiv = 0 And nTargetOrder >= 1 ) Then
					nTargetOrder -= 1
					nTopDiv = 9
					' もう一度計算し直す
					objDivOrder = new clsStringNumber( clsStringNumber.mlng10pow( nTargetOrder Mod 9 ) )
					With Nothing
						Dim nBlockShift		As Integer
						nBlockShift = nTargetOrder \ 9
						If nBlockShift > 0 Then
							objDivOrder = objDivOrder.RetLShiftLng9( 1 )
						End If
					End With

					objDivBase = objDivOrder * objA1A2SNum
					objDivMultied = objDivBase * System.Convert.ToInt64( nTopDiv )
					objBetaRemainTmp = objBetaRemain - objDivMultied

					'Console.WriteLine( "RetDivideUNum_DivideByTopBlock objBetaRemainTmp.Minus = -1 And nTopDiv = 1 Done : objBetaRemainTmp={0}, objDivBase={1},objDivMultied={2}  ", _ 
					'											objBetaRemainTmp.ToString(), objDivBase.ToString(), objDivMultied.ToString() )
					'Console.ReadLine()

				End If
					

			

				If objBetaRemainTmp.Minus = -1 Then

					Dim nTryCnt			As Integer
					nTryCnt = 0
					Do
						nTopDiv -= 1
						objBetaRemainTmp += objDivBase
						If objBetaRemainTmp.Minus = 1 Then
							Exit Do
						End If
						If nTopDiv = 0 Then
							Exit Do
						End If                    

						nTryCnt += 1
						If nTryCnt = 5 Then
							Console.WriteLine( "Program Archiecture Error : posstion 5(Toplock-objBeta), divShift adding is done for more than 5 times! " )
						End If
					Loop
				
				ElseIf objBetaRemainTmp > objDivBase Then
					
					Dim nTryCnt			As Integer
					nTryCnt = 0
					Do
						nTopDiv += 1
						objBetaRemainTmp -= objDivBase
						If objBetaRemainTmp < objDivBase Then
							Exit Do
						End If

						nTryCnt += 1
						If nTryCnt = 5 Then
							Console.WriteLine( "Program Archiecture Error : posstion 6(Toplock-objBeta), divShift reducing is done for more than 5 times! " )
						End If
					Loop

				End If
				objBetaRemain = objBetaRemainTmp


				objBeta += objDivOrder * System.Convert.ToInt64( nTopDiv ) 

				If objBetaRemain < objA1A2SNum Then
					Exit For
				End If


			Next


			'Console.WriteLine( "RetDivideUNum_DivideByTopBlock  beta done : objBeta={0}, objA1SNum={1},objA1A2SNum={2}  ", _ 
			'											objBeta.ToString(), objA1SNum.ToString(), objA1A2SNum.ToString() )
			'Console.ReadLine()

		End With

		Dim bBetaMultiDo		As Boolean

		bBetaMultiDo = True
		If objBeta.Lng9Length = 2 Then
			If objBeta.Lng9( 0 ) = 0 And objBeta.Lng9( 1 ) = 1L Then
			bBetaMultiDo = False

			'Console.WriteLine( "If objBeta.Lng9( 0 ) = 0 And objBeta.Lng9( 1 ) = 1L Then : objDivideShifted = {0}, objBeta = {1}, lngQuotient = {2} lngDivide = {3} lngRemain = {4} ", _ 
			'					 objDivideShifted.ToString(), objBeta.ToString(), lngQuotient, lngDivide, lngRemain )
			'	Console.ReadLine()
			End If
		End If

RetDivideUNum_DivideByTopBlock_BETADICIDED:

		Do
			'Console.WriteLine( "ByTopBlock :Top :  objRemain = {0}, objDivide = {1} ", objRemain.ToString(), objDivide.ToString()  )
			'Console.ReadLine()

			Dim nCompare       As Integer
			nCompare = objRemain.CompareUNum( objDivide )


			'Console.WriteLine( "ByTopBlock :Top2 :  objDivide = " & objDivide.ToString() )
			If nCompare = 0 Then
				objQuotient = objQuotient + 1L
				objQuotient.Minus = Me.Minus * objDivide.Minus
				objRemain = new clsStringNumber( 0L )
				Return True
			ElseIf nCompare = -1 Then
				If objRemain.Minus = -1 Then
					Do While objRemain.Minus = -1
						objRemain += objDivide
						objQuotient = objQuotient - 1

						'Console.WriteLine( "ByTopBlock : nCompare =-1 Loop, objRemain= " & objRemain.ToString() )
					Loop
				End If    
				objQuotient.Minus = Me.Minus * objDivide.Minus
				Return True
			ElseIf objRemain.Lng9Length = objDivide.Lng9Length Then
					Exit Do
			End If

			'Console.WriteLine( "ByTopBlock :Top :  nCompare = " & nCompare.ToString() )
			
			Dim lngRemain               As System.Int64
			Dim lngDivide               As System.Int64
			Dim lngQuotient             As System.Int64
			Dim objTmpMultplied         As clsStringNumber
			Dim objTmpRemain            As clsStringNumber
			Dim nTargetOrder			As System.Int64
			nTargetOrder = objRemain.Lng9Length - objDivide.Lng9Length
			lngRemain = objRemain.Lng9( objRemain.Lng9Length - 1 )
			lngDivide = objDivide.Lng9( objDivide.Lng9Length - 1 )
			If lngRemain < lngDivide Then
				nTargetOrder -= 1
				lngRemain *= LNG9_MAX + 1
				lngRemain += objRemain.Lng9( objRemain.Lng9Length - 2 )
			End If
			lngQuotient = lngRemain \ lngDivide

			' Q' = lngRemain /( 1 + α ) 
			' objDivide =  A1 * 10^9n  +  A2 * 10^9(n-1) +  A3 * 10^9(n-2) + ....
			'             1                 A2 
			'   α =   ------  ・ -----------
			'             A1            10^9
			' 
			'   B1・C1=B2・C2
			'    B1=B2・(1+α)
			'   C1・(1+α)=C2
			'   Q' = lngRemain / ( 1 + α )
			'              A1 * 10^9
			'       = --------------------------  ≅ XXXXYYYY 
			'               A1 * 10^9 + A2

			Dim objDivideShifted        As clsStringNumber
			objDivideShifted = objDivide.RetLShiftLng9( nTargetOrder )
			'objTmpMultplied = objDivideShifted * lngQuotient

			'Console.WriteLine( "lngQuotient Before : objDivideShifted = {0}, objBeta = {1}, lngQuotient = {2} lngDivide = {3} lngRemain = {4} ", _ 
			'						 objDivideShifted.ToString(), objBeta.ToString(), lngQuotient, lngDivide, lngRemain )


			If bBetaMultiDo Then
				lngQuotient *= objBeta.Lng9( 0 )
				lngQuotient \= LNG9_MAX + 1
			End If
			
			objTmpMultplied = lngQuotient * objDivideShifted
			'objTmpMultplied = objTmpMultplied.RetRShiftLng9( 1 )


			'Console.WriteLine( "lngQuotient done : objDivideShifted = {0}, objBeta = {1}, lngQuotient = {2} lngDivide = {3} lngRemain = {4} ", _ 
			'						 objDivideShifted.ToString(), objBeta.ToString(), lngQuotient, lngDivide, lngRemain )


			objTmpRemain = objRemain - objTmpMultplied
			'Console.WriteLine( "objQuotient.Lng9Length = {0}, nTargetOrder= {1}, objTmpMultplied={2}, objDivideShifted={3} ", _
			'						objQuotient.Lng9Length, nTargetOrder, objTmpMultplied.ToString(), objDivideShifted.ToString() )


			' やっぱこの if 文使わんと駄目だわ。beta値かけるの忘れてたわｗ
			If (objTmpRemain.Minus = -1 And lngQuotient = 1 ) Or _ 
				( lngQuotient = 0 And nTargetOrder >= 1 ) Then
				nTargetOrder -= 1
				lngQuotient = LNG9_MAX
				' もう一度計算し直す

				objDivideShifted = objDivide.RetLShiftLng9( nTargetOrder )

				If bBetaMultiDo Then
					lngQuotient *= objBeta.Lng9( 0 )
					lngQuotient \= LNG9_MAX + 1
				End If

				objTmpMultplied = lngQuotient * objDivideShifted

				objTmpRemain = objRemain - objTmpMultplied

				'Console.WriteLine( "ByTopBlock : Retryed objDivideShifted = " & objDivideShifted.ToString() )
			End If




			If objTmpRemain.Minus = -1 Then

				Dim nTryCnt			As Integer
				nTryCnt = 0
				Do

					'Console.WriteLine( "If objTmpRemain.Minus = -1 Then Loop :  lngQuotient = {0}, objTmpRemain = {1}, objDivideShifted = {2} ", _ 
					'									lngQuotient, objRemain.ToString(), objDivideShifted.ToString()  )
					'Console.ReadLine()

					lngQuotient -= 1
					objTmpRemain += objDivideShifted
					If objTmpRemain.Minus = 1 Then
						Exit Do
					End If
					If lngQuotient = 0 Then
						Exit Do
					End If 
					nTryCnt += 1
					If nTryCnt = 5 Then
						Console.WriteLine( "Program Archiecture Error : posstion 1, divShift adding is done for more than 5 times! " )
					End IF
				Loop
			
			ElseIf objTmpRemain > objDivideShifted Then
				
				Dim nTryCnt			As Integer
				nTryCnt = 0
				Do


					
					'Console.WriteLine( "ElseIf objTmpRemain > objDivideShifted Then Loop :  lngQuotient = {0}, objTmpRemain = {1}, objDivideShifted = {2} ", _ 
					'									lngQuotient, objRemain.ToString(), objDivideShifted.ToString()  )
					'Console.ReadLine()
					lngQuotient += 1
					objTmpRemain -= objDivideShifted
					If objTmpRemain < objDivideShifted Then
						Exit Do
					End If
					nTryCnt += 1
					If nTryCnt = 5 Then
						Call clsPub.ErrMsg( _
							new System.Diagnostics.StackTrace( true ) , _ 
							"Program Archiecture Error : posstion 2, divShift reducing is done for more than 5 times! " & _ 
							"objRemain=""" & objRemain.ToString() & """ objDivide=""" & objDivide.ToString() & """ lngRemain=""" & lngRemain.ToString() & _ 
							""" lngDivide=""" & lngDivide.ToString() & """"  )

						Console.WriteLine(  )
					End IF

				Loop

			End If



			Dim objQuotientPart               As clsStringNumber
			objQuotientPart = new clsStringNumber( lngQuotient )
			objQuotientPart = objQuotientPart.RetLShiftLng9( nTargetOrder )

			'Console.WriteLine( "objQuotientPart? objQuotient = {0}, objQuotientPart= {1} objQuotientPart= ", objQuotient.ToString(), objQuotientPart.ToString() )
			'For nCnt As Integer = 0 To objQuotientPart.Lng9Length - 1
			'	Console.Write( "  |{0}|  ", objQuotientPart.Lng9( objQuotientPart.Lng9Length - 1 - nCnt  ).ToString() )
			'Next
			'Console.ReadLine()

			objQuotient = objQuotient + objQuotientPart

			'objTmpMultplied = lngQuotient * objDivideShifted
			'objRemain = objRemain - objTmpMultplied
			objRemain = objTmpRemain
			Call objRemain.CutZeroBlock()

			'Console.WriteLine( "Loop End  :result objRemain = {0}, objQuotient= {1} objQuotient=", objRemain.ToString(), objQuotient.ToString() )
			'For nCnt As Integer = 0 To objQuotient.Lng9Length - 1
			'	Console.Write( "  |{0}|  ", objQuotient.Lng9( objQuotient.Lng9Length - 1 - nCnt  ).ToString() )
			'Next
			'Console.ReadLine()

		Loop

	End Function

	Friend Sub RetDivideUNum_DivideBlock1_TopNumInf ( ByVal lngValue As SYstem.Int64, ByRef nNum As Integer, ByRef nNum2nd As Integer, ByRef nOder As Integer )
		Dim nFind		As Integer

		nFind = System.Array.BinarySearch( clsStringNumber.mlng10pow, lngValue )
		If nFind >= 0 Then
			nNum = 1
			nOder = nFind
			Exit Sub
		End If

		nFind = Not nFind
		If nFind = 0 Then
			nNum = 0
			nOder = 0
		End If
		nFind -= 1

		nNum = System.Convert.ToInt32( lngValue \ clsStringNumber.mlng10pow( nFind ) )
		If nFind > 0 Then
			nNum2nd = System.Convert.ToInt32( ( lngValue - nNum * (clsStringNumber.mlng10pow( nFind ) ) ) \ clsStringNumber.mlng10pow( nFind - 1 ) )
		Else
			nNum2nd = 0
		End If
		nOder = nFind


		'Dim nCnt        As Integer
		'For nCnt = 0 To 10
		'	If lngValue < 10 Then
		'		nNum = System.Convert.ToInt32( lngValue )
		'		nOder = nCnt
		'		Exit For
		'	End If
		'	lngValue \= 10
		'Next    
	End Sub

	Friend Sub RetDivideUNum_DivideBySameBlockOrder( ByVal objRemain As clsStringNumber, ByVal objDivide As clsStringNumber, ByRef objQuotientResult As clsStringNumber, ByRef objRemainResult As clsStringNumber )
		Dim nDivNum      As Integer
		Dim nDivNum2nd   As Integer
		Dim nDivOrder    As Integer

		Call Me.RetDivideUNum_DivideBlock1_TopNumInf( _
							objDivide.Lng9( objDivide.Lng9Length - 1 ), _ 
							nDivNum, nDivNum2nd, _ 
							nDivOrder )
		
		objQuotientResult = new clsStringNumber( 0 )
		objRemainResult = objRemain.Clone()

		Do

			'Console.WriteLine( "SameBlockOrder 1 : objRemainResult = {0}, objDivide= {1}", objRemainResult.ToString(), objDivide.ToString() )
			'Console.ReadLine()

			If objRemainResult.Minus = -1 Then
				Do
					objRemainResult += objDivide
					objQuotientResult -= 1L
					If objRemainResult.Minus = 1 Then
						Exit Sub
					End If
				Loop
			ElseIf objRemainResult < objDivide Then
				Exit Sub
			End If
				
				
			Dim nRemainNum			As Integer
			Dim nRemainOrder		As Integer
			With Nothing
				Dim lngRemainNum      As System.Int64
				lngRemainNum = objRemainResult.Lng9( objRemainResult.Lng9Length - 1 )
				nRemainOrder = 0
				Do
					If lngRemainNum < 100L Then
						If ( lngRemainNum \ 10L ) <=  nDivNum Then
							nRemainNum = System .Convert.ToInt32( lngRemainNum )
							Exit Do
						End If
					End If
					If lngRemainNum < 10L Then
						nRemainNum = System .Convert.ToInt32( lngRemainNum )
						Exit Do
					End If 
					lngRemainNum \= 10L
					nRemainOrder += 1
				Loop
			End With

			Dim blDiv2ndNumUsed		As Boolean
			' 実効割る数
			Dim nDivNumEffective       As Integer	
			' 実効商のの桁
			Dim nDivOrderEffective     As Integer

			blDiv2ndNumUsed = False
			If nRemainOrder < nDivOrder Then
				' オーダー逆転現象が出るらしい。マジ？
				' 一応てきとーに対処しとくけど大丈夫かよ・・・びくびく。
				nDivNumEffective = 10 * nDivNum + nDivNum2nd
				nDivOrderEffective = nDivOrder - 1
				blDiv2ndNumUsed = True
			Else
				nDivNumEffective = nDivNum
				nDivOrderEffective = nDivOrder
			End If

			Dim nTargetOrder      As Integer
			nTargetOrder = nRemainOrder - nDivOrderEffective

			Dim nDiv              As Integer
			ndiv = nRemainNum \ nDivNumEffective

			' 割る数の頭2桁目を補正掛け算する
			If blDiv2ndNumUsed = False Then
				If nDivNum2nd > 0 Then

					' 割る数 objDivide の最上位の数 nDivNum, 上から2桁目の数 nDivNum2nd である。

					' 割る数を nDivNum だけで評価した際の仮の商は
					'                 nRemainNum
					' 仮の商   nDiv  = ------------------
					'                   nDivNum

					'                           1 
					' 補正後の仮の商 = nDiv * --------------------- 
					'									1         nDivNum2nd
					'							1 + --------- * ------- 
					'								nDivNum       10
					'
					'                                10 * nDivNum
					'               = nDiv * -------------------------------
					'                            10 * nDivNum + nDivNum2nd


					nDiv *= 10 * nDivNumEffective
					nDiv \= 10 * nDivNumEffective + nDivNum2nd

					' nDiv = 0 だと無限ループハマりするので
					' 念のためコード足しとくｗ
					If nDiv = 0 Then
						nDiv = 1
					End If
				End If
			End If

			Dim objDivMultiBase    As clsStringNumber
			Dim objDivMulti        As clsStringNumber
			
			If nTargetOrder > 9 Or nTargetOrder < 0 Then
				Console.WriteLine( "SameBlock : nTargetOrder > 9 Or nTargetOrder < 0 ! nTargetOrder={0} nRemainOrder={1} nDivOrder={2}  nDivOrderEffective={3}     lngRemainNum={4} nDivNum={5} nRemainNum={6} objDivide={7}", _
				                                                                       nTargetOrder,    nRemainOrder,    nDivOrder,     nDivOrderEffective,        objRemainResult.Lng9( objRemainResult.Lng9Length - 1 ), nDivNum, nRemainNum, objDivide  )
			Console.ReadLine()

			End If
			objDivMultiBase = new clsStringNumber( clsStringNumber.mlng10pow( nTargetOrder )  )
			objDivMultiBase *= objDivide
			objDivMulti = objDivMultiBase * System.Convert.ToInt64( nDiv )

			'Console.WriteLine( "SameBlockOrder : objDivMultiBase = {0}, objDivMulti= {1}", objDivMultiBase.ToString(), objDivMulti.ToString() )


			objRemainResult -= objDivMulti
			'Console.WriteLine( "SameBlockOrder : minused objRemainResult = {0}, objDivide= {1}", objRemainResult.ToString(), objDivide.ToString() )
			'Console.ReadLine()


			If objRemainResult.Minus = -1 Then

				Dim nTryCnt			As Integer
				nTryCnt = 0
				Do
					objRemainResult += objDivMultiBase
					nDiv -= 1
					If nDiv = 0 Then
						Exit Do
					End If
					If objRemainResult.Minus = 1 Then
						Exit Do
					End If
					nTryCnt += 1
					If nTryCnt = 5 Then
						Console.WriteLine( "Program Archiecture Error : posstion 3(sameblock), divShift adding is done for more than 5 times! " )
					End If

				Loop

			ElseIf objRemainResult > objDivMultiBase Then
				
				Dim nTryCnt			As Integer
				nTryCnt = 0
				Do
					objRemainResult -= objDivMultiBase
					nDiv += 1
					If nDiv = 0 Then
						Exit Do
					End If
					If objRemainResult < objDivMultiBase Then
						Exit Do
					End If
					nTryCnt += 1
					If nTryCnt = 5 Then
						Console.WriteLine( "Program Archiecture Error : posstion 4(sameblock), divShift reducing is done for more than 5 times! " )
					End If

				Loop
			End If


			objQuotientResult += _ 
				System.Convert.ToInt64( nDiv ) _ 
					* clsStringNumber.mlng10pow( nTargetOrder )

			'Console.WriteLine( "SameBlockOrder : Loop Bottom objQuotientResult = {0}, objRemainResult= {1} objQuotientResult.Lng9 =", objQuotientResult.ToString(), objRemainResult.ToString() )
			'For nCnt As Integer = 0 To objQuotientResult.Lng9Length - 1
			'	Console.Write( "  |{0}|  ", objQuotientResult.Lng9( objQuotientResult.Lng9Length - 1 - nCnt  ).ToString() )
			'Next
			'Console.ReadLine()


		Loop


	End Sub


End Class



End NameSpace

